//------------------------------------------------------------------------------------------------------
//
// DARCIIConfig.c
//
// Data structure used to describe DARC-II behaviour
//
// Place in separate file for tidiness - it has a lot of initializers
//
// (c) FlexiPanel Ltd
//
// Normally, the initialization data is overwritten by FlexiPanel Designer.
// However, if you choose to customize DARC-II, you will be replacing the ToothPIC resource code
// rather than programming wirelessly and you will have to configure this structure manually
//
//-------------------------------------------------------------------------------------------------------


#include "..\ToothPIC.h"
#include <p18f6720.h>
#include "DARCIIConfig.h"


// locate DARC Config structure at 0x00FE00
// Designer.exe expects it there and will write the configuration data there
// Will be zero until programmed
#pragma romdata DARCconfig=DARCII_CONFIG_LOC
rom DARCIIConfig DARCcfg = {

0x55,			// 	unsigned char Initialized;		// equal to 0x55 if this structure contains valid data
"DARC-II",		//	unsigned char ServerName[MAXNAMELENGTHINCZ];
"0000",			//	unsigned char PINCode[MAXNAMELENGTHINCZ];
0,				// 	unsigned char SecurityLevel;	
0,				//	unsigned char ResetOnError;		// nonzero if DARC should reset on error
0,				//	unsigned char nAnalogChannel;	// number of analog channels
0,				//	unsigned char IsRefAN2;			// if nonzero AN2 is -ve reference 
0,				//	unsigned char IsRefAN3;			// if nonzero AN3 is +ve reference 
0,				//	unsigned char PinFuncAN0;		// 0 = input, 1 = output; ignored if analog 
0,				//	unsigned char PinFuncAN1;		// 0 = input, 1 = output; ignored if analog
0,				//	unsigned char PinFuncAN2;		// 0 = input, 1 = output; ignored if analog
0,				//	unsigned char PinFuncAN3;		// 0 = input, 1 = output; ignored if analog
0,				//	unsigned char PinFuncAN4;		// 0 = input, 1 = output; ignored if analog
0,				//	unsigned char PinFuncAN5;		// 0 = input, 1 = output; ignored if analog
0,				//	unsigned char PinFuncAN6;		// 0 = input, 1 = output; ignored if analog
0,				//	unsigned char PinFuncAN7;		// 0 = input, 1 = output; ignored if analog
0,				//	unsigned char PinFuncAN8;		// 0 = input, 1 = output; ignored if analog
0,				//	unsigned char PinFuncAN9;		// 0 = input, 1 = output; ignored if analog
0,				//	unsigned char PinFuncAN10;		// 0 = input, 1 = output; ignored if analog
0,				//	unsigned char PinFuncAN11;		// 0 = input, 1 = output; ignored if analog
0,				//	unsigned char PinFuncCCP1;		// 0 = input, 1 = output, 2 = PWM output
0,				//	unsigned char PinFuncCCP2;		// 0 = input, 1 = output, 2 = PWM output
0,				//	unsigned char PinFuncCCP3;		// 0 = input, 1 = output, 2 = PWM output
0,				//	unsigned char PinFuncCCP4;		// 0 = input, 1 = output, 2 = PWM output
0,				//	unsigned char PinFuncCCP5;		// 0 = input, 1 = output, 2 = PWM output
0,				//	unsigned char PinFuncINT0;		// 0 = input, 1 = output
0,				//	unsigned char PinFuncINT1;		// 0 = input, 1 = output
0,				//	unsigned char PinFuncTxD;		// 0 = input, 1 = output
0,				//	unsigned char PinFuncRxD;		// 0 = input, 1 = output
0,				//	unsigned char PinFuncSDA;		// 0 = input, 1 = output
0,				//	unsigned char PinFuncSCL;		// 0 = input, 1 = output
0,				//	unsigned char PinFuncSDO;		// 0 = input, 1 = output
0,				//	unsigned char ParallelA;		// Number of bits in parallel I/O; input or output must be specified separately
0,				//	unsigned char ParallelB;		// Number of bits in parallel I/O; input or output must be specified separately
0,				//	unsigned char ParallelC;		// Number of bits in parallel I/O; input or output must be specified separately
0,				//	unsigned char TimeBase;			// 0xFF = no PWM, 0 = 0.2us, 1 = 0.8us, 2 = 3.2us
0,				//	unsigned char PWMPeriod;
0,				//	unsigned char RefreshRate;		// 0 = Never, 1 = 100ms, 2 = 200ms etc
{
0,				//	unsigned char ToFromPin[0];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[1];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[2];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[3];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[4];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[5];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[6];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[7];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[8];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[9];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[10];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[11];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[12];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[13];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[14];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[15];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[16];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[17];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[18];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[19];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[20];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[21];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[22];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[23];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[24];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[25];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[26];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[27];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[28];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[29];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[30];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[31];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[32];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[33];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[34];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[35];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[36];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[37];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[38];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[39];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[40];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[41];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[42];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[43];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[44];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[45];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[46];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[47];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[48];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[49];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[50];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[51];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[52];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[53];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[54];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[55];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[56];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[57];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[58];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[59];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[60];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[61];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[62];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[63];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[64];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[65];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[66];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[67];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[68];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[69];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[70];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[71];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[72];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[73];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[74];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[75];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[76];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[77];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[78];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[79];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[80];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[81];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[82];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[83];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[84];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[85];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[86];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[87];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[88];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[89];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[90];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[91];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[92];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[93];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[94];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[95];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[96];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[97];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[98];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[99];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[100];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[101];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[102];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[103];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[104];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[105];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[106];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[107];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[108];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[109];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[110];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[111];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[112];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[113];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[114];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[115];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[116];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[117];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[118];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[119];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[120];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[121];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[122];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[123];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[124];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[125];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[126];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[127];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[128];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[129];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[130];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[131];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[132];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[133];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[134];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[135];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[136];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[137];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[138];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[139];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[140];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[141];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[142];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[143];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[144];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[145];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[146];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[147];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[148];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[149];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[150];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[151];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[152];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[153];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[154];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[155];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[156];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[157];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[158];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[159];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[160];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[161];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[162];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[163];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[164];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[165];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[166];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[167];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[168];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[169];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[170];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[171];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[172];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[173];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[174];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[175];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[176];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[177];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[178];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[179];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[180];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[181];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[182];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[183];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[184];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[185];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[186];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[187];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[188];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[189];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[190];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[191];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[192];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[193];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[194];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[195];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[196];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[197];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[198];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[199];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[200];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[201];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[202];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[203];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[204];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[205];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[206];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[207];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[208];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[209];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[210];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[211];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[212];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[213];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[214];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[215];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[216];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[217];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[218];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[219];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[220];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[221];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[222];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[223];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[224];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[225];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[226];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[227];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[228];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[229];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[230];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[231];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[232];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[233];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[234];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[235];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[236];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[237];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[238];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[239];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[240];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[241];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[242];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[243];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[244];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[245];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[246];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[247];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[248];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[249];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[250];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[251];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[252];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[253];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[254];	// Pin associated with control with ID equal to index number - see below
0,				//	unsigned char ToFromPin[255];	// Pin associated with control with ID equal to index number - see below
}
};

#pragma code


// ToFromPin definitions

// ----------------------------------------------------------------------------------------
// Value | Button/Image/Latch/Text |           List             |   Number   |  DT Matrix | 
// ----------------------------------------------------------------------------------------
//   0   |           None          |           None             |    None    |    None    |  
//   1   |           AN0           |        Parallel A          |    AN0     |    AN0     |   
//   2   |           AN1           |        Parallel B          |    AN1     |    AN1     |   
//   3   |           AN2           |        Parallel C          |    AN2     |    AN2     |  
//   4   |           AN3           |           CCP1             |    AN3     |    AN3     |  
//   5   |           AN4           |           CCP2             |    AN4     |    AN4     | 
//   6   |           AN5           |           CCP3             |    AN5     |    AN5     |
//   7   |           AN6           |           CCP4             |    AN6     |    AN6     |
//   8   |           AN7           |           CCP5             |    AN7     |    AN7     |
//   9   |           AN8           |           None             |    AN8     |    AN8     |
//   10  |           AN9           |           None             |    AN9     |    AN9     |
//   11  |           AN10          |           None             |    AN10    |    AN10    |
//   12  |           AN11          |           None             |    AN11    |    AN11    |
//   13  |           CCP1          |           None             | Parallel A | Parallel A |
//   14  |           CCP2          |           None             | Parallel B | Parallel B |
//   15  |           CCP3          |           None             | Parallel C | Parallel C |
//   16  |           CCP4          |           None             |    CCP1    |    None    |
//   17  |           CCP5          |           None             |    CCP2    |    None    |
//   18  |           INT0          |           None             |    CCP3    |    None    |
//   19  |           INT1          |           None             |    CCP4    |    None    |
//   20  |           TxD           |           None             |    CCP5    |    None    |
//   21  |           RxD           |           None             |    None    |    None    |
//   22  |           SDA           |           None             |    None    |    None    |
//   23  |           SCL           |           None             |    None    |    None    |
//   24  |           SDO           |           None             |    None    |    None    |
// ----------------------------------------------------------------------------------------


