//-------------------------------------------------------------------------------------------
//
//  HelloWorldRes.h
//
//  Toothpick User Interface definitions generated by FlexiPanel Designer 
//
//  Created at 11:50:39 on 3/5/06
//
//  ROM allocation: 0x010000 to 0x01029F
//  RAM allocation:   0x0100 to   0x0110
//
//-------------------------------------------------------------------------------------------
//
//                      MEMORY MAP 
//
//    Addresses are relative to start of storage identifier 
//
//     Storage     Address    Size     Allocation 
//    =========    =======   ======    ================================ 
//     STR_RAM      0100      0010     Text1 (01) value (DWord aligned)
//    STR_RAM01     0000      0020     FlexiPanel server info (DWord aligned)
//    STR_RAM01     0020      0004     Dialog info array (DWord aligned)
//    STR_RAM01     0024      0208     Client-specific profile info array (DWord aligned)
//    STR_RAM01     022C      0038     Control info array (DWord aligned)
//    STR_ROM01     0264      0001     Change Text (02) value 
//    STR_ROM01     0265      0017     Text1 (01) control info
//    STR_ROM01     027C      0010     Text1 (01) non-volatile data storage
//    STR_ROM01     028C      0014     Change Text (02) control info
//
//-------------------------------------------------------------------------------------------
//
//
//  Dialog definitions 

// Dialog index / data structure for dialog whose first control is Text1 
#define DlgID_Text1_1 0x00    
#define DlgD_Text1_1 pDlgD[DlgID_Text1_1]    


//-------------------------------------------------------------------------------------------

//  Text1 control (01 - Text)

// Control ID
#define ID_Text1_1 0x0001    

// Control Index / data structure pointer 
#define CtlIdx_Text1_1 0x0000    
#define CtlD_Text1_1 pCtlD[CtlIdx_Text1_1]    

// MaxBytes_Text1_1 is maximum storage of Text1 in bytes
#define MaxBytes_Text1_1 0x0010

// Get_Text1_1( pUChar ) gets Text1 value.  pUChar must be pointer to unsigned char array, minimum length 16 bytes 
#define Get_Text1_1( pUChar ) GetBytes( STR_RAM, 0x0000, pUChar, 16 )

// pText1_1 is an unsigned char RAM pointer which may also be used to set or get the array
#define pText1_1 ((unsigned char*)0x0100)

// Set_Text1_1( pRUChar, pUChar ) sets Text1 value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_Text1_1( pRUChar, pUChar ) SetBytes( STR_RAM, 0x0000, pRUChar, pUChar, 16 )

// SetUp_Text1_1( pRUChar, pUChar ) sets Text1 value and automatically updates client if connected 
#define SetUp_Text1_1( pRUChar, pUChar ) { Set_Text1_1( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_Text1_1, 0 ); }

// EnsureVisible_Text1_1 scrolls control Text1 into view on the client.  
#define EnsureVisible_Text1_1 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Text1_1, &lVal ); }

// Show_Text1_1 sets that control Text1 to visible.  
#define Show_Text1_1 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Text1_1, &lVal ); }

// Hide_Text1_1 sets that control Text1 to visible.  
#define Hide_Text1_1 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Text1_1, &lVal ); }

// Enable_Text1_1 enables Text1.  
#define Enable_Text1_1 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Text1_1, &lVal ); }

// Disable_Text1_1 disables Text1.  
#define Disable_Text1_1 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Text1_1, &lVal ); }

// SetCol_Text1_1( NewCol ) sets the color of control Text1.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Text1_1( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Text1_1, lVal ); }


//-------------------------------------------------------------------------------------------

//  Change Text control (02 - Button)

// Control ID
#define ID_Change_Text_2 0x0002    

// Control Index / data structure pointer 
#define CtlIdx_Change_Text_2 0x0001    
#define CtlD_Change_Text_2 pCtlD[CtlIdx_Change_Text_2]    

// EnsureVisible_Change_Text_2 scrolls control Change Text into view on the client.  
#define EnsureVisible_Change_Text_2 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Change_Text_2, &lVal ); }

// Show_Change_Text_2 sets that control Change Text to visible.  
#define Show_Change_Text_2 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Change_Text_2, &lVal ); }

// Hide_Change_Text_2 sets that control Change Text to visible.  
#define Hide_Change_Text_2 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Change_Text_2, &lVal ); }

// Enable_Change_Text_2 enables Change Text.  
#define Enable_Change_Text_2 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Change_Text_2, &lVal ); }

// Disable_Change_Text_2 disables Change Text.  
#define Disable_Change_Text_2 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Change_Text_2, &lVal ); }

// SetCol_Change_Text_2( NewCol ) sets the color of control Change Text.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Change_Text_2( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Change_Text_2, lVal ); }


//-------------------------------------------------------------------------------------------

//  Other definitions 

// DESIGNERCHOOSESNAME definition ensures that the profile is uploaded every time this file
// is regenerated
#define DESIGNERCHOOSESNAME
#define DESIGNERCHOSENNAME "HelloWorldFxPA"

//
//-------------------------------------------------------------------------------------------

