//-------------------------------------------------------------------------------------------
//
//  OpenToothRes.h
//
//  ToothPIC User Interface and mesh map definitions generated by FlexiPanel Designer 
//
//  Created at 16:58:21 on 3/9/05
//
//  ROM allocation: 0x010000 to 0x014EF9
//  RAM allocation:   0x0100 to   0x017E
//
//-------------------------------------------------------------------------------------------
//
//                      MEMORY MAP 
//
//    Addresses are relative to start of storage identifier 
//
//     Storage     Address    Size     Allocation 
//    =========    =======   ======    ================================ 
//     STR_RAM      0000      0004     RegUserList (02) value (DWord aligned)
//     STR_RAM      0004      0004     Access Log (3E) value (DWord aligned)
//     STR_RAM      0008      0004     NewUserList (08) value (DWord aligned)
//     STR_RAM      000C      0008     DeletionDate (37) value (DWord aligned)
//     STR_RAM      0014      0008     FromTime (29) value (DWord aligned)
//     STR_RAM      001C      0008     ToTime (2B) value (DWord aligned)
//     STR_RAM      0024      0008     TimeNow (23) value (DWord aligned)
//     STR_RAM      002C      0001     Cancel (0A) value 
//     STR_RAM      002D      0015     UserName (0E) value 
//     STR_RAM      0042      0021     BTID (40) value 
//     STR_RAM      0063      0001     Monday (2C) value 
//     STR_RAM      0064      0001     Tuesday (2D) value 
//     STR_RAM      0065      0001     Wednesday (2E) value 
//     STR_RAM      0066      0001     Thursday (2F) value 
//     STR_RAM      0067      0001     Friday (30) value 
//     STR_RAM      0068      0001     Saturday (31) value 
//     STR_RAM      0069      0001     Sunday (32) value 
//     STR_RAM      006A      0001     In DST now (4E) value 
//     STR_RAM      006B      0013     UserName (47) value 
//    STR_RAM01     0000      0020     FlexiPanel server info (DWord aligned)
//    STR_RAM01     0020      0020     Dialog info array (DWord aligned)
//    STR_RAM01     0040      1628     Client-specific profile info array (DWord aligned)
//    STR_RAM01     1668      06AC     Control info array (DWord aligned)
//    STR_ROM01     1D14      0010     DelDateText (36) value (DWord aligned)
//    STR_ROM01     1D24      0010     From (28) value (DWord aligned)
//    STR_ROM01     1D34      0010     To (2A) value (DWord aligned)
//    STR_ROM01     1D44      0004     TriggerList (16) value (DWord aligned)
//    STR_ROM01     1D48      0004     LogStyle (18) value (DWord aligned)
//    STR_ROM01     1D4C      0004     WeigandStyle (4D) value (DWord aligned)
//    STR_ROM01     1D50      0010     TimeNowText (22) value (DWord aligned)
//    STR_ROM01     1D60      0004     DTSStyle (24) value (DWord aligned)
//    STR_ROM01     1D64      0010     WarnText (46) value (DWord aligned)
//    STR_ROM01     1D74      0012     RegUsersText (01) value (Word aligned)
//    STR_ROM01     1D86      000E     AccessLogText (0C) value (Word aligned)
//    STR_ROM01     1D94      0012     AddUsersText (3B) value (Word aligned)
//    STR_ROM01     1DA6      006A     ScanAdvice (4B) value (Word aligned)
//    STR_ROM01     1E10      0012     SetUsersText (10) value (Word aligned)
//    STR_ROM01     1E22      000A     UserNameText (1D) value (Word aligned)
//    STR_ROM01     1E2C      0012     KeyText (19) value (Word aligned)
//    STR_ROM01     1E3E      0001     Add... (03) value 
//    STR_ROM01     1E3F      0001     Modify... (11) value 
//    STR_ROM01     1E40      0001     Delete (04) value 
//    STR_ROM01     1E41      0001     Access Log... (3A) value 
//    STR_ROM01     1E42      0001     Setup... (06) value 
//    STR_ROM01     1E43      0001     Close (07) value 
//    STR_ROM01     1E44      0029     AddNoMore (3F) value 
//    STR_ROM01     1E6D      0057     NoNewUsers (4A) value 
//    STR_ROM01     1EC4      0001     Close (3C) value 
//    STR_ROM01     1EC5      0001     Select (09) value 
//    STR_ROM01     1EC6      0001     Expiry Settings... (26) value 
//    STR_ROM01     1EC7      0001     Timed Entry Settings... (34) value 
//    STR_ROM01     1EC8      0001     OK (0B) value 
//    STR_ROM01     1EC9      0001     Cancel (0F) value 
//    STR_ROM01     1ECA      0015     ExpiryText (27) value 
//    STR_ROM01     1EDF      0001     Close (38) value 
//    STR_ROM01     1EE0      0015     TimedEntryText (35) value 
//    STR_ROM01     1EF5      0001     Close (33) value 
//    STR_ROM01     1EF6      0009     Settings (12) value 
//    STR_ROM01     1EFF      0009     Key (1C) value 
//    STR_ROM01     1F08      000D     UserPinText (41) value 
//    STR_ROM01     1F15      0009     UserPinKey (42) value 
//    STR_ROM01     1F1E      0001     Close (21) value 
//    STR_ROM01     1F1F      0001     Confirm (48) value 
//    STR_ROM01     1F20      0001     Cancel (49) value 
//    STR_ROM01     1F21      0027     RegUsersText (01) control info
//    STR_ROM01     1F48      130F     RegUserList (02) control info
//    STR_ROM01     3257      0004     RegUserList (02) non-volatile data storage
//    STR_ROM01     325B      000F     Add... (03) control info
//    STR_ROM01     326A      0012     Modify... (11) control info
//    STR_ROM01     327C      000F     Delete (04) control info
//    STR_ROM01     328B      0016     Access Log... (3A) control info
//    STR_ROM01     32A1      0011     Setup... (06) control info
//    STR_ROM01     32B2      000E     Close (07) control info
//    STR_ROM01     32C0      000F     Manual (45) control info
//    STR_ROM01     32CF      02BC     Manual (45) non-volatile data storage
//    STR_ROM01     358B      001B     AddNoMore (3F) control info
//    STR_ROM01     35A6      001C     NoNewUsers (4A) control info
//    STR_ROM01     35C2      0028     AccessLogText (0C) control info
//    STR_ROM01     35EA      0E95     Access Log (3E) control info
//    STR_ROM01     447F      0004     Access Log (3E) non-volatile data storage
//    STR_ROM01     4483      000E     Close (3C) control info
//    STR_ROM01     4491      0027     AddUsersText (3B) control info
//    STR_ROM01     44B8      00E0     NewUserList (08) control info
//    STR_ROM01     4598      0004     NewUserList (08) non-volatile data storage
//    STR_ROM01     459C      000F     Select (09) control info
//    STR_ROM01     45AB      000F     Cancel (0A) control info
//    STR_ROM01     45BA      0001     Cancel (0A) non-volatile data storage
//    STR_ROM01     45BB      001C     ScanAdvice (4B) control info
//    STR_ROM01     45D7      0027     SetUsersText (10) control info
//    STR_ROM01     45FE      001E     UserNameText (1D) control info
//    STR_ROM01     461C      001A     UserName (0E) control info
//    STR_ROM01     4636      0015     UserName (0E) non-volatile data storage
//    STR_ROM01     464B      001B     Expiry Settings... (26) control info
//    STR_ROM01     4666      0020     Timed Entry Settings... (34) control info
//    STR_ROM01     4686      0016     BTID (40) control info
//    STR_ROM01     469C      0021     BTID (40) non-volatile data storage
//    STR_ROM01     46BD      000B     OK (0B) control info
//    STR_ROM01     46C8      000F     Cancel (0F) control info
//    STR_ROM01     46D7      0025     ExpiryText (27) control info
//    STR_ROM01     46FC      001D     DelDateText (36) control info
//    STR_ROM01     4719      0038     DeletionDate (37) control info
//    STR_ROM01     4751      0008     DeletionDate (37) non-volatile data storage
//    STR_ROM01     4759      000E     Close (38) control info
//    STR_ROM01     4767      0029     TimedEntryText (35) control info
//    STR_ROM01     4790      0016     From (28) control info
//    STR_ROM01     47A6      0024     FromTime (29) control info
//    STR_ROM01     47CA      0008     FromTime (29) non-volatile data storage
//    STR_ROM01     47D2      0014     To (2A) control info
//    STR_ROM01     47E6      0022     ToTime (2B) control info
//    STR_ROM01     4808      0008     ToTime (2B) non-volatile data storage
//    STR_ROM01     4810      000F     Monday (2C) control info
//    STR_ROM01     481F      0001     Monday (2C) non-volatile data storage
//    STR_ROM01     4820      0010     Tuesday (2D) control info
//    STR_ROM01     4830      0001     Tuesday (2D) non-volatile data storage
//    STR_ROM01     4831      0012     Wednesday (2E) control info
//    STR_ROM01     4843      0001     Wednesday (2E) non-volatile data storage
//    STR_ROM01     4844      0011     Thursday (2F) control info
//    STR_ROM01     4855      0001     Thursday (2F) non-volatile data storage
//    STR_ROM01     4856      000F     Friday (30) control info
//    STR_ROM01     4865      0001     Friday (30) non-volatile data storage
//    STR_ROM01     4866      0011     Saturday (31) control info
//    STR_ROM01     4877      0001     Saturday (31) non-volatile data storage
//    STR_ROM01     4878      000F     Sunday (32) control info
//    STR_ROM01     4887      0001     Sunday (32) non-volatile data storage
//    STR_ROM01     4888      000E     Close (33) control info
//    STR_ROM01     4896      0023     Settings (12) control info
//    STR_ROM01     48B9      00DE     TriggerList (16) control info
//    STR_ROM01     4997      005E     LogStyle (18) control info
//    STR_ROM01     49F5      00FB     WeigandStyle (4D) control info
//    STR_ROM01     4AF0      0019     KeyText (19) control info
//    STR_ROM01     4B09      0015     Key (1C) control info
//    STR_ROM01     4B1E      001D     UserPinText (41) control info
//    STR_ROM01     4B3B      001C     UserPinKey (42) control info
//    STR_ROM01     4B57      001D     TimeNowText (22) control info
//    STR_ROM01     4B74      0033     TimeNow (23) control info
//    STR_ROM01     4BA7      0008     TimeNow (23) non-volatile data storage
//    STR_ROM01     4BAF      02C3     DTSStyle (24) control info
//    STR_ROM01     4E72      0013     In DST now (4E) control info
//    STR_ROM01     4E85      0001     In DST now (4E) non-volatile data storage
//    STR_ROM01     4E86      000E     Close (21) control info
//    STR_ROM01     4E94      001A     WarnText (46) control info
//    STR_ROM01     4EAE      001A     UserName (47) control info
//    STR_ROM01     4EC8      0013     UserName (47) non-volatile data storage
//    STR_ROM01     4EDB      0010     Confirm (48) control info
//    STR_ROM01     4EEB      000F     Cancel (49) control info
//
//-------------------------------------------------------------------------------------------
//
//
//  Dialog definitions 

// Dialog ID for dialog starting with control RegUsersText 
#define DlgID_RegUsersText_1 0x00    

// Dialog ID for dialog starting with control AccessLogText 
#define DlgID_AccessLogText_C 0x01    

// Dialog ID for dialog starting with control AddUsersText 
#define DlgID_AddUsersText_3B 0x02    

// Dialog ID for dialog starting with control SetUsersText 
#define DlgID_SetUsersText_10 0x03    

// Dialog ID for dialog starting with control ExpiryText 
#define DlgID_ExpiryText_27 0x04    

// Dialog ID for dialog starting with control TimedEntryText 
#define DlgID_TimedEntryText_35 0x05    

// Dialog ID for dialog starting with control Settings 
#define DlgID_Settings_12 0x06    

// Dialog ID for dialog starting with control WarnText 
#define DlgID_WarnText_46 0x07    


//-------------------------------------------------------------------------------------------

//  RegUsersText control (01 - Text)

#define ID_RegUsersText_1 0x0001    

// MaxBytes_RegUsersText_1 is maximum storage of RegUsersText in bytes
#define MaxBytes_RegUsersText_1 0x0012

// Get_RegUsersText_1( pUChar ) gets RegUsersText value.  pUChar must be pointer to unsigned char array, minimum length 18 bytes 
#define Get_RegUsersText_1( pUChar ) GetBytes( STR_ROM01, 0x1D74, pUChar, 18 )

// pRegUsersText_1 is an unsigned char ROM pointer which may also be used to get the array (use Set_RegUsersText_1() to set it) 
#define pRegUsersText_1 ((rom unsigned char*)0x011D74)

// Set_RegUsersText_1( pRUChar, pUChar ) sets RegUsersText value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_RegUsersText_1( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1D74, pRUChar, pUChar, 18 )

// SetUp_RegUsersText_1( pRUChar, pUChar ) sets RegUsersText value and automatically updates client if connected 
#define SetUp_RegUsersText_1( pRUChar, pUChar ) { Set_RegUsersText_1( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_RegUsersText_1, 0 ); }

// EnsureVisible_RegUsersText_1 scrolls control RegUsersText into view on the client.  
#define EnsureVisible_RegUsersText_1 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_RegUsersText_1, &lVal ); }

// Show_RegUsersText_1 sets that control RegUsersText to visible.  
#define Show_RegUsersText_1 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_RegUsersText_1, &lVal ); }

// Hide_RegUsersText_1 sets that control RegUsersText to visible.  
#define Hide_RegUsersText_1 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_RegUsersText_1, &lVal ); }

// Enable_RegUsersText_1 enables RegUsersText.  
#define Enable_RegUsersText_1 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_RegUsersText_1, &lVal ); }

// Disable_RegUsersText_1 disables RegUsersText.  
#define Disable_RegUsersText_1 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_RegUsersText_1, &lVal ); }

// SetCol_RegUsersText_1( NewCol ) sets the color of control RegUsersText.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_RegUsersText_1( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_RegUsersText_1, lVal ); }


//-------------------------------------------------------------------------------------------

//  RegUserList control (02 - List)

#define ID_RegUserList_2 0x0002    

// Get_RegUserList_2( pLong ) gets RegUserList value.  pLong must be pointer to 4-byte signed integer
// if the value could fit into a short or char, you could get fewer bytes 
#define Get_RegUserList_2( pLong ) GetBytes( STR_RAM, 0x0000, pLong, sizeof(long) )

// plRegUserList_2 is an unsigned long RAM pointer which may also be used to set or get the value
#define plRegUserList_2 ((unsigned long*)0x0100)

// psRegUserList_2 is an unsigned short RAM pointer which may also be used to set or get the value if it is in the range 0 to 65535
#define psRegUserList_2 ((unsigned short*)0x0100)

// pcRegUserList_2 is an unsigned char RAM pointer which may also be used to set or get the value if it is in the range 0 to 255
#define pcRegUserList_2 ((unsigned char*)0x0100)

// Set_RegUserList_2( pRLong, pLong ) sets RegUserList value.  pRULong must be rom pointer to 4-byte signed integer or pULong must 
// be pointer to 4-byte signed integer, the other pointer must be zero
// if the value could fit into a short or char, you could set fewer bytes 
#define Set_RegUserList_2( pRLong, pULong ) SetBytes( STR_RAM, 0x0000, pRULong, pULong, sizeof(long) )

// SetUp_RegUserList_2( pRLong, pLong ) sets RegUserList value and automatically updates client if connected 
#define SetUp_RegUserList_2( pRLong, pLong ) { Set_RegUserList_2( pRLong, pLong ); FxPCommand( FxPC_CtlUpdate, ID_RegUserList_2, 0 ); }

// NumItem_RegUserList_2 is the number of items in the list 
#define NumItem_RegUserList_2 1

// SetListText_RegUserList_2 / SetListCount_RegUserList_2 define the contents of the list.
// If you need to modify the list items you may do so but you should then
// retransmit the dialog (i.e. call FxPC_SetDialog) to update the client.
// The items should be sequential, each separated from the next with a zero terminator,
// and the storage area originally allocated (ItemTextMaxBytes_RegUserList_2) should never
// be exceeded.  Call SetListCount_$s if you modify the number of items,
#define ListTextLoc_RegUserList_2 0x1F5B
#define ListTextStr_RegUserList_2 STR_ROM01
#define SetListText_RegUserList_2( pRUStr, pUStr ) SetBytes( ListTextStr_RegUserList_2, ListTextLoc_RegUserList_2, pRUStr, pUStr, ItemTextMaxBytes_RegUserList_2 )
#define ListNumLoc_RegUserList_2 0x1F53
#define ListNumStr_RegUserList_2 STR_ROM01
#define SetListNum_RegUserList_2( pRUStr, pUStr ) SetBytes( ListNumStr_RegUserList_2, ListNumLoc_RegUserList_2, pRUStr, pUStr, sizeof( long ) )
#define ItemTextMaxBytes_RegUserList_2 0x12ED

// EnsureVisible_RegUserList_2 scrolls control RegUserList into view on the client.  
#define EnsureVisible_RegUserList_2 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_RegUserList_2, &lVal ); }

// Show_RegUserList_2 sets that control RegUserList to visible.  
#define Show_RegUserList_2 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_RegUserList_2, &lVal ); }

// Hide_RegUserList_2 sets that control RegUserList to visible.  
#define Hide_RegUserList_2 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_RegUserList_2, &lVal ); }

// Enable_RegUserList_2 enables RegUserList.  
#define Enable_RegUserList_2 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_RegUserList_2, &lVal ); }

// Disable_RegUserList_2 disables RegUserList.  
#define Disable_RegUserList_2 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_RegUserList_2, &lVal ); }

// SetCol_RegUserList_2( NewCol ) sets the color of control RegUserList.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_RegUserList_2( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_RegUserList_2, lVal ); }


//-------------------------------------------------------------------------------------------

//  Add... control (03 - Button)

#define ID_Add____3 0x0003    

// EnsureVisible_Add____3 scrolls control Add... into view on the client.  
#define EnsureVisible_Add____3 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Add____3, &lVal ); }

// Show_Add____3 sets that control Add... to visible.  
#define Show_Add____3 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Add____3, &lVal ); }

// Hide_Add____3 sets that control Add... to visible.  
#define Hide_Add____3 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Add____3, &lVal ); }

// Enable_Add____3 enables Add....  
#define Enable_Add____3 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Add____3, &lVal ); }

// Disable_Add____3 disables Add....  
#define Disable_Add____3 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Add____3, &lVal ); }

// SetCol_Add____3( NewCol ) sets the color of control Add....  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Add____3( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Add____3, lVal ); }


//-------------------------------------------------------------------------------------------

//  Modify... control (11 - Button)

#define ID_Modify____11 0x0004    

// EnsureVisible_Modify____11 scrolls control Modify... into view on the client.  
#define EnsureVisible_Modify____11 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Modify____11, &lVal ); }

// Show_Modify____11 sets that control Modify... to visible.  
#define Show_Modify____11 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Modify____11, &lVal ); }

// Hide_Modify____11 sets that control Modify... to visible.  
#define Hide_Modify____11 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Modify____11, &lVal ); }

// Enable_Modify____11 enables Modify....  
#define Enable_Modify____11 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Modify____11, &lVal ); }

// Disable_Modify____11 disables Modify....  
#define Disable_Modify____11 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Modify____11, &lVal ); }

// SetCol_Modify____11( NewCol ) sets the color of control Modify....  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Modify____11( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Modify____11, lVal ); }


//-------------------------------------------------------------------------------------------

//  Delete control (04 - Button)

#define ID_Delete_4 0x0005    

// EnsureVisible_Delete_4 scrolls control Delete into view on the client.  
#define EnsureVisible_Delete_4 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Delete_4, &lVal ); }

// Show_Delete_4 sets that control Delete to visible.  
#define Show_Delete_4 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Delete_4, &lVal ); }

// Hide_Delete_4 sets that control Delete to visible.  
#define Hide_Delete_4 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Delete_4, &lVal ); }

// Enable_Delete_4 enables Delete.  
#define Enable_Delete_4 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Delete_4, &lVal ); }

// Disable_Delete_4 disables Delete.  
#define Disable_Delete_4 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Delete_4, &lVal ); }

// SetCol_Delete_4( NewCol ) sets the color of control Delete.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Delete_4( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Delete_4, lVal ); }


//-------------------------------------------------------------------------------------------

//  Access Log... control (3A - Button)

#define ID_Access_Log____3A 0x0006    

// EnsureVisible_Access_Log____3A scrolls control Access Log... into view on the client.  
#define EnsureVisible_Access_Log____3A { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Access_Log____3A, &lVal ); }

// Show_Access_Log____3A sets that control Access Log... to visible.  
#define Show_Access_Log____3A { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Access_Log____3A, &lVal ); }

// Hide_Access_Log____3A sets that control Access Log... to visible.  
#define Hide_Access_Log____3A { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Access_Log____3A, &lVal ); }

// Enable_Access_Log____3A enables Access Log....  
#define Enable_Access_Log____3A { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Access_Log____3A, &lVal ); }

// Disable_Access_Log____3A disables Access Log....  
#define Disable_Access_Log____3A { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Access_Log____3A, &lVal ); }

// SetCol_Access_Log____3A( NewCol ) sets the color of control Access Log....  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Access_Log____3A( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Access_Log____3A, lVal ); }


//-------------------------------------------------------------------------------------------

//  Setup... control (06 - Button)

#define ID_Setup____6 0x0007    

// EnsureVisible_Setup____6 scrolls control Setup... into view on the client.  
#define EnsureVisible_Setup____6 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Setup____6, &lVal ); }

// Show_Setup____6 sets that control Setup... to visible.  
#define Show_Setup____6 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Setup____6, &lVal ); }

// Hide_Setup____6 sets that control Setup... to visible.  
#define Hide_Setup____6 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Setup____6, &lVal ); }

// Enable_Setup____6 enables Setup....  
#define Enable_Setup____6 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Setup____6, &lVal ); }

// Disable_Setup____6 disables Setup....  
#define Disable_Setup____6 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Setup____6, &lVal ); }

// SetCol_Setup____6( NewCol ) sets the color of control Setup....  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Setup____6( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Setup____6, lVal ); }


//-------------------------------------------------------------------------------------------

//  Close control (07 - Button)

#define ID_Close_7 0x0008    

// EnsureVisible_Close_7 scrolls control Close into view on the client.  
#define EnsureVisible_Close_7 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Close_7, &lVal ); }

// Show_Close_7 sets that control Close to visible.  
#define Show_Close_7 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Close_7, &lVal ); }

// Hide_Close_7 sets that control Close to visible.  
#define Hide_Close_7 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Close_7, &lVal ); }

// Enable_Close_7 enables Close.  
#define Enable_Close_7 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Close_7, &lVal ); }

// Disable_Close_7 disables Close.  
#define Disable_Close_7 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Close_7, &lVal ); }

// SetCol_Close_7( NewCol ) sets the color of control Close.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Close_7( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Close_7, lVal ); }


//-------------------------------------------------------------------------------------------

//  Manual control (45 - Files)

#define ID_Manual_45 0x0009    

// EnsureVisible_Manual_45 scrolls control Manual into view on the client.  
#define EnsureVisible_Manual_45 { unsigned long lVal = 0x00100010; FxPCommand( FxPC_SetProps, ID_Manual_45, &lVal ); }

// Show_Manual_45 sets that control Manual to visible.  
#define Show_Manual_45 { unsigned long lVal = 0x00100000; FxPCommand( FxPC_SetProps, ID_Manual_45, &lVal ); }

// Hide_Manual_45 sets that control Manual to visible.  
#define Hide_Manual_45 { unsigned long lVal = 0x00100001; FxPCommand( FxPC_SetProps, ID_Manual_45, &lVal ); }

// Enable_Manual_45 enables Manual.  
#define Enable_Manual_45 { unsigned long lVal = 0x00100000; FxPCommand( FxPC_SetProps, ID_Manual_45, &lVal ); }

// Disable_Manual_45 disables Manual.  
#define Disable_Manual_45 { unsigned long lVal = 0x00100080; FxPCommand( FxPC_SetProps, ID_Manual_45, &lVal ); }

// SetCol_Manual_45( NewCol ) sets the color of control Manual.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Manual_45( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00100040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Manual_45, lVal ); }


//-------------------------------------------------------------------------------------------

//  AddNoMore control (3F - Message)

#define ID_AddNoMore_3F 0x000A    

// ShowMessage_AddNoMore_3F displays the AddNoMore message.  If a response is expected, it will come in the form of an FxPC_MsgResp event.
#define ShowMessage_AddNoMore_3F { unsigned long lVal = 0x00030000; FxPCommand( FxPC_SetProps, ID_AddNoMore_3F, &lVal ); }

// MaxBytes_AddNoMore_3F is maximum storage of AddNoMore in bytes
#define MaxBytes_AddNoMore_3F 0x0029

// Get_AddNoMore_3F( pUChar ) gets AddNoMore message text.  pUChar must be pointer to unsigned char array, minimum length 41 bytes 
#define Get_AddNoMore_3F( pUChar ) GetBytes( STR_ROM01, 0x1E44, pUChar, 41 )

// pAddNoMore_3F is an unsigned char ROM pointer which may also be used to get the message text (use Set_AddNoMore_3F() to set it) 
#define pAddNoMore_3F ((rom unsigned char*)0x011E44)

// Set_AddNoMore_3F( pRUChar, pUChar ) sets AddNoMore message text.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_AddNoMore_3F( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1E44, pRUChar, pUChar, 41 )

// SetUp_AddNoMore_3F( pRUChar, pUChar ) sets AddNoMore value and automatically updates client if connected 
#define SetUp_AddNoMore_3F( pRUChar, pUChar ) { Set_AddNoMore_3F( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_AddNoMore_3F, 0 ); }


//-------------------------------------------------------------------------------------------

//  NoNewUsers control (4A - Message)

#define ID_NoNewUsers_4A 0x000B    

// ShowMessage_NoNewUsers_4A displays the NoNewUsers message.  If a response is expected, it will come in the form of an FxPC_MsgResp event.
#define ShowMessage_NoNewUsers_4A { unsigned long lVal = 0x00050000; FxPCommand( FxPC_SetProps, ID_NoNewUsers_4A, &lVal ); }

// MaxBytes_NoNewUsers_4A is maximum storage of NoNewUsers in bytes
#define MaxBytes_NoNewUsers_4A 0x0057

// Get_NoNewUsers_4A( pUChar ) gets NoNewUsers message text.  pUChar must be pointer to unsigned char array, minimum length 87 bytes 
#define Get_NoNewUsers_4A( pUChar ) GetBytes( STR_ROM01, 0x1E6D, pUChar, 87 )

// pNoNewUsers_4A is an unsigned char ROM pointer which may also be used to get the message text (use Set_NoNewUsers_4A() to set it) 
#define pNoNewUsers_4A ((rom unsigned char*)0x011E6D)

// Set_NoNewUsers_4A( pRUChar, pUChar ) sets NoNewUsers message text.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_NoNewUsers_4A( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1E6D, pRUChar, pUChar, 87 )

// SetUp_NoNewUsers_4A( pRUChar, pUChar ) sets NoNewUsers value and automatically updates client if connected 
#define SetUp_NoNewUsers_4A( pRUChar, pUChar ) { Set_NoNewUsers_4A( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_NoNewUsers_4A, 0 ); }


//-------------------------------------------------------------------------------------------

//  AccessLogText control (0C - Text)

#define ID_AccessLogText_C 0x0101    

// MaxBytes_AccessLogText_C is maximum storage of AccessLogText in bytes
#define MaxBytes_AccessLogText_C 0x000E

// Get_AccessLogText_C( pUChar ) gets AccessLogText value.  pUChar must be pointer to unsigned char array, minimum length 14 bytes 
#define Get_AccessLogText_C( pUChar ) GetBytes( STR_ROM01, 0x1D86, pUChar, 14 )

// pAccessLogText_C is an unsigned char ROM pointer which may also be used to get the array (use Set_AccessLogText_C() to set it) 
#define pAccessLogText_C ((rom unsigned char*)0x011D86)

// Set_AccessLogText_C( pRUChar, pUChar ) sets AccessLogText value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_AccessLogText_C( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1D86, pRUChar, pUChar, 14 )

// SetUp_AccessLogText_C( pRUChar, pUChar ) sets AccessLogText value and automatically updates client if connected 
#define SetUp_AccessLogText_C( pRUChar, pUChar ) { Set_AccessLogText_C( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_AccessLogText_C, 0 ); }

// EnsureVisible_AccessLogText_C scrolls control AccessLogText into view on the client.  
#define EnsureVisible_AccessLogText_C { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_AccessLogText_C, &lVal ); }

// Show_AccessLogText_C sets that control AccessLogText to visible.  
#define Show_AccessLogText_C { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_AccessLogText_C, &lVal ); }

// Hide_AccessLogText_C sets that control AccessLogText to visible.  
#define Hide_AccessLogText_C { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_AccessLogText_C, &lVal ); }

// Enable_AccessLogText_C enables AccessLogText.  
#define Enable_AccessLogText_C { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_AccessLogText_C, &lVal ); }

// Disable_AccessLogText_C disables AccessLogText.  
#define Disable_AccessLogText_C { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_AccessLogText_C, &lVal ); }

// SetCol_AccessLogText_C( NewCol ) sets the color of control AccessLogText.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_AccessLogText_C( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_AccessLogText_C, lVal ); }


//-------------------------------------------------------------------------------------------

//  Access Log control (3E - List)

#define ID_Access_Log_3E 0x0102    

// Get_Access_Log_3E( pLong ) gets Access Log value.  pLong must be pointer to 4-byte signed integer
// if the value could fit into a short or char, you could get fewer bytes 
#define Get_Access_Log_3E( pLong ) GetBytes( STR_RAM, 0x0004, pLong, sizeof(long) )

// plAccess_Log_3E is an unsigned long RAM pointer which may also be used to set or get the value
#define plAccess_Log_3E ((unsigned long*)0x0104)

// psAccess_Log_3E is an unsigned short RAM pointer which may also be used to set or get the value if it is in the range 0 to 65535
#define psAccess_Log_3E ((unsigned short*)0x0104)

// pcAccess_Log_3E is an unsigned char RAM pointer which may also be used to set or get the value if it is in the range 0 to 255
#define pcAccess_Log_3E ((unsigned char*)0x0104)

// Set_Access_Log_3E( pRLong, pLong ) sets Access Log value.  pRULong must be rom pointer to 4-byte signed integer or pULong must 
// be pointer to 4-byte signed integer, the other pointer must be zero
// if the value could fit into a short or char, you could set fewer bytes 
#define Set_Access_Log_3E( pRLong, pULong ) SetBytes( STR_RAM, 0x0004, pRULong, pULong, sizeof(long) )

// SetUp_Access_Log_3E( pRLong, pLong ) sets Access Log value and automatically updates client if connected 
#define SetUp_Access_Log_3E( pRLong, pLong ) { Set_Access_Log_3E( pRLong, pLong ); FxPCommand( FxPC_CtlUpdate, ID_Access_Log_3E, 0 ); }

// NumItem_Access_Log_3E is the number of items in the list 
#define NumItem_Access_Log_3E 1

// SetListText_Access_Log_3E / SetListCount_Access_Log_3E define the contents of the list.
// If you need to modify the list items you may do so but you should then
// retransmit the dialog (i.e. call FxPC_SetDialog) to update the client.
// The items should be sequential, each separated from the next with a zero terminator,
// and the storage area originally allocated (ItemTextMaxBytes_Access_Log_3E) should never
// be exceeded.  Call SetListCount_$s if you modify the number of items,
#define ListTextLoc_Access_Log_3E 0x35FD
#define ListTextStr_Access_Log_3E STR_ROM01
#define SetListText_Access_Log_3E( pRUStr, pUStr ) SetBytes( ListTextStr_Access_Log_3E, ListTextLoc_Access_Log_3E, pRUStr, pUStr, ItemTextMaxBytes_Access_Log_3E )
#define ListNumLoc_Access_Log_3E 0x35F5
#define ListNumStr_Access_Log_3E STR_ROM01
#define SetListNum_Access_Log_3E( pRUStr, pUStr ) SetBytes( ListNumStr_Access_Log_3E, ListNumLoc_Access_Log_3E, pRUStr, pUStr, sizeof( long ) )
#define ItemTextMaxBytes_Access_Log_3E 0x0E74

// EnsureVisible_Access_Log_3E scrolls control Access Log into view on the client.  
#define EnsureVisible_Access_Log_3E { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Access_Log_3E, &lVal ); }

// Show_Access_Log_3E sets that control Access Log to visible.  
#define Show_Access_Log_3E { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Access_Log_3E, &lVal ); }

// Hide_Access_Log_3E sets that control Access Log to visible.  
#define Hide_Access_Log_3E { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Access_Log_3E, &lVal ); }

// Enable_Access_Log_3E enables Access Log.  
#define Enable_Access_Log_3E { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Access_Log_3E, &lVal ); }

// Disable_Access_Log_3E disables Access Log.  
#define Disable_Access_Log_3E { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Access_Log_3E, &lVal ); }

// SetCol_Access_Log_3E( NewCol ) sets the color of control Access Log.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Access_Log_3E( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Access_Log_3E, lVal ); }


//-------------------------------------------------------------------------------------------

//  Close control (3C - Button)

#define ID_Close_3C 0x0103    

// EnsureVisible_Close_3C scrolls control Close into view on the client.  
#define EnsureVisible_Close_3C { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Close_3C, &lVal ); }

// Show_Close_3C sets that control Close to visible.  
#define Show_Close_3C { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Close_3C, &lVal ); }

// Hide_Close_3C sets that control Close to visible.  
#define Hide_Close_3C { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Close_3C, &lVal ); }

// Enable_Close_3C enables Close.  
#define Enable_Close_3C { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Close_3C, &lVal ); }

// Disable_Close_3C disables Close.  
#define Disable_Close_3C { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Close_3C, &lVal ); }

// SetCol_Close_3C( NewCol ) sets the color of control Close.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Close_3C( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Close_3C, lVal ); }


//-------------------------------------------------------------------------------------------

//  AddUsersText control (3B - Text)

#define ID_AddUsersText_3B 0x0201    

// MaxBytes_AddUsersText_3B is maximum storage of AddUsersText in bytes
#define MaxBytes_AddUsersText_3B 0x0012

// Get_AddUsersText_3B( pUChar ) gets AddUsersText value.  pUChar must be pointer to unsigned char array, minimum length 18 bytes 
#define Get_AddUsersText_3B( pUChar ) GetBytes( STR_ROM01, 0x1D94, pUChar, 18 )

// pAddUsersText_3B is an unsigned char ROM pointer which may also be used to get the array (use Set_AddUsersText_3B() to set it) 
#define pAddUsersText_3B ((rom unsigned char*)0x011D94)

// Set_AddUsersText_3B( pRUChar, pUChar ) sets AddUsersText value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_AddUsersText_3B( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1D94, pRUChar, pUChar, 18 )

// SetUp_AddUsersText_3B( pRUChar, pUChar ) sets AddUsersText value and automatically updates client if connected 
#define SetUp_AddUsersText_3B( pRUChar, pUChar ) { Set_AddUsersText_3B( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_AddUsersText_3B, 0 ); }

// EnsureVisible_AddUsersText_3B scrolls control AddUsersText into view on the client.  
#define EnsureVisible_AddUsersText_3B { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_AddUsersText_3B, &lVal ); }

// Show_AddUsersText_3B sets that control AddUsersText to visible.  
#define Show_AddUsersText_3B { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_AddUsersText_3B, &lVal ); }

// Hide_AddUsersText_3B sets that control AddUsersText to visible.  
#define Hide_AddUsersText_3B { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_AddUsersText_3B, &lVal ); }

// Enable_AddUsersText_3B enables AddUsersText.  
#define Enable_AddUsersText_3B { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_AddUsersText_3B, &lVal ); }

// Disable_AddUsersText_3B disables AddUsersText.  
#define Disable_AddUsersText_3B { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_AddUsersText_3B, &lVal ); }

// SetCol_AddUsersText_3B( NewCol ) sets the color of control AddUsersText.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_AddUsersText_3B( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_AddUsersText_3B, lVal ); }


//-------------------------------------------------------------------------------------------

//  NewUserList control (08 - List)

#define ID_NewUserList_8 0x0202    

// Get_NewUserList_8( pLong ) gets NewUserList value.  pLong must be pointer to 4-byte signed integer
// if the value could fit into a short or char, you could get fewer bytes 
#define Get_NewUserList_8( pLong ) GetBytes( STR_RAM, 0x0008, pLong, sizeof(long) )

// plNewUserList_8 is an unsigned long RAM pointer which may also be used to set or get the value
#define plNewUserList_8 ((unsigned long*)0x0108)

// psNewUserList_8 is an unsigned short RAM pointer which may also be used to set or get the value if it is in the range 0 to 65535
#define psNewUserList_8 ((unsigned short*)0x0108)

// pcNewUserList_8 is an unsigned char RAM pointer which may also be used to set or get the value if it is in the range 0 to 255
#define pcNewUserList_8 ((unsigned char*)0x0108)

// Set_NewUserList_8( pRLong, pLong ) sets NewUserList value.  pRULong must be rom pointer to 4-byte signed integer or pULong must 
// be pointer to 4-byte signed integer, the other pointer must be zero
// if the value could fit into a short or char, you could set fewer bytes 
#define Set_NewUserList_8( pRLong, pULong ) SetBytes( STR_RAM, 0x0008, pRULong, pULong, sizeof(long) )

// SetUp_NewUserList_8( pRLong, pLong ) sets NewUserList value and automatically updates client if connected 
#define SetUp_NewUserList_8( pRLong, pLong ) { Set_NewUserList_8( pRLong, pLong ); FxPCommand( FxPC_CtlUpdate, ID_NewUserList_8, 0 ); }

// NumItem_NewUserList_8 is the number of items in the list 
#define NumItem_NewUserList_8 1

// SetListText_NewUserList_8 / SetListCount_NewUserList_8 define the contents of the list.
// If you need to modify the list items you may do so but you should then
// retransmit the dialog (i.e. call FxPC_SetDialog) to update the client.
// The items should be sequential, each separated from the next with a zero terminator,
// and the storage area originally allocated (ItemTextMaxBytes_NewUserList_8) should never
// be exceeded.  Call SetListCount_$s if you modify the number of items,
#define ListTextLoc_NewUserList_8 0x44CB
#define ListTextStr_NewUserList_8 STR_ROM01
#define SetListText_NewUserList_8( pRUStr, pUStr ) SetBytes( ListTextStr_NewUserList_8, ListTextLoc_NewUserList_8, pRUStr, pUStr, ItemTextMaxBytes_NewUserList_8 )
#define ListNumLoc_NewUserList_8 0x44C3
#define ListNumStr_NewUserList_8 STR_ROM01
#define SetListNum_NewUserList_8( pRUStr, pUStr ) SetBytes( ListNumStr_NewUserList_8, ListNumLoc_NewUserList_8, pRUStr, pUStr, sizeof( long ) )
#define ItemTextMaxBytes_NewUserList_8 0x00BE

// EnsureVisible_NewUserList_8 scrolls control NewUserList into view on the client.  
#define EnsureVisible_NewUserList_8 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_NewUserList_8, &lVal ); }

// Show_NewUserList_8 sets that control NewUserList to visible.  
#define Show_NewUserList_8 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_NewUserList_8, &lVal ); }

// Hide_NewUserList_8 sets that control NewUserList to visible.  
#define Hide_NewUserList_8 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_NewUserList_8, &lVal ); }

// Enable_NewUserList_8 enables NewUserList.  
#define Enable_NewUserList_8 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_NewUserList_8, &lVal ); }

// Disable_NewUserList_8 disables NewUserList.  
#define Disable_NewUserList_8 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_NewUserList_8, &lVal ); }

// SetCol_NewUserList_8( NewCol ) sets the color of control NewUserList.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_NewUserList_8( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_NewUserList_8, lVal ); }


//-------------------------------------------------------------------------------------------

//  Select control (09 - Button)

#define ID_Select_9 0x0203    

// EnsureVisible_Select_9 scrolls control Select into view on the client.  
#define EnsureVisible_Select_9 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Select_9, &lVal ); }

// Show_Select_9 sets that control Select to visible.  
#define Show_Select_9 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Select_9, &lVal ); }

// Hide_Select_9 sets that control Select to visible.  
#define Hide_Select_9 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Select_9, &lVal ); }

// Enable_Select_9 enables Select.  
#define Enable_Select_9 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Select_9, &lVal ); }

// Disable_Select_9 disables Select.  
#define Disable_Select_9 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Select_9, &lVal ); }

// SetCol_Select_9( NewCol ) sets the color of control Select.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Select_9( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Select_9, lVal ); }


//-------------------------------------------------------------------------------------------

//  Cancel control (0A - Button)

#define ID_Cancel_A 0x0204    

// EnsureVisible_Cancel_A scrolls control Cancel into view on the client.  
#define EnsureVisible_Cancel_A { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Cancel_A, &lVal ); }

// Show_Cancel_A sets that control Cancel to visible.  
#define Show_Cancel_A { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Cancel_A, &lVal ); }

// Hide_Cancel_A sets that control Cancel to visible.  
#define Hide_Cancel_A { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Cancel_A, &lVal ); }

// Enable_Cancel_A enables Cancel.  
#define Enable_Cancel_A { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Cancel_A, &lVal ); }

// Disable_Cancel_A disables Cancel.  
#define Disable_Cancel_A { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Cancel_A, &lVal ); }

// SetCol_Cancel_A( NewCol ) sets the color of control Cancel.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Cancel_A( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Cancel_A, lVal ); }


//-------------------------------------------------------------------------------------------

//  ScanAdvice control (4B - Text)

#define ID_ScanAdvice_4B 0x0205    

// MaxBytes_ScanAdvice_4B is maximum storage of ScanAdvice in bytes
#define MaxBytes_ScanAdvice_4B 0x006A

// Get_ScanAdvice_4B( pUChar ) gets ScanAdvice value.  pUChar must be pointer to unsigned char array, minimum length 106 bytes 
#define Get_ScanAdvice_4B( pUChar ) GetBytes( STR_ROM01, 0x1DA6, pUChar, 106 )

// pScanAdvice_4B is an unsigned char ROM pointer which may also be used to get the array (use Set_ScanAdvice_4B() to set it) 
#define pScanAdvice_4B ((rom unsigned char*)0x011DA6)

// Set_ScanAdvice_4B( pRUChar, pUChar ) sets ScanAdvice value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_ScanAdvice_4B( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1DA6, pRUChar, pUChar, 106 )

// SetUp_ScanAdvice_4B( pRUChar, pUChar ) sets ScanAdvice value and automatically updates client if connected 
#define SetUp_ScanAdvice_4B( pRUChar, pUChar ) { Set_ScanAdvice_4B( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_ScanAdvice_4B, 0 ); }

// EnsureVisible_ScanAdvice_4B scrolls control ScanAdvice into view on the client.  
#define EnsureVisible_ScanAdvice_4B { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_ScanAdvice_4B, &lVal ); }

// Show_ScanAdvice_4B sets that control ScanAdvice to visible.  
#define Show_ScanAdvice_4B { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_ScanAdvice_4B, &lVal ); }

// Hide_ScanAdvice_4B sets that control ScanAdvice to visible.  
#define Hide_ScanAdvice_4B { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_ScanAdvice_4B, &lVal ); }

// Enable_ScanAdvice_4B enables ScanAdvice.  
#define Enable_ScanAdvice_4B { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_ScanAdvice_4B, &lVal ); }

// Disable_ScanAdvice_4B disables ScanAdvice.  
#define Disable_ScanAdvice_4B { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_ScanAdvice_4B, &lVal ); }

// SetCol_ScanAdvice_4B( NewCol ) sets the color of control ScanAdvice.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_ScanAdvice_4B( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_ScanAdvice_4B, lVal ); }


//-------------------------------------------------------------------------------------------

//  SetUsersText control (10 - Text)

#define ID_SetUsersText_10 0x0301    

// MaxBytes_SetUsersText_10 is maximum storage of SetUsersText in bytes
#define MaxBytes_SetUsersText_10 0x0012

// Get_SetUsersText_10( pUChar ) gets SetUsersText value.  pUChar must be pointer to unsigned char array, minimum length 18 bytes 
#define Get_SetUsersText_10( pUChar ) GetBytes( STR_ROM01, 0x1E10, pUChar, 18 )

// pSetUsersText_10 is an unsigned char ROM pointer which may also be used to get the array (use Set_SetUsersText_10() to set it) 
#define pSetUsersText_10 ((rom unsigned char*)0x011E10)

// Set_SetUsersText_10( pRUChar, pUChar ) sets SetUsersText value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_SetUsersText_10( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1E10, pRUChar, pUChar, 18 )

// SetUp_SetUsersText_10( pRUChar, pUChar ) sets SetUsersText value and automatically updates client if connected 
#define SetUp_SetUsersText_10( pRUChar, pUChar ) { Set_SetUsersText_10( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_SetUsersText_10, 0 ); }

// EnsureVisible_SetUsersText_10 scrolls control SetUsersText into view on the client.  
#define EnsureVisible_SetUsersText_10 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_SetUsersText_10, &lVal ); }

// Show_SetUsersText_10 sets that control SetUsersText to visible.  
#define Show_SetUsersText_10 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_SetUsersText_10, &lVal ); }

// Hide_SetUsersText_10 sets that control SetUsersText to visible.  
#define Hide_SetUsersText_10 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_SetUsersText_10, &lVal ); }

// Enable_SetUsersText_10 enables SetUsersText.  
#define Enable_SetUsersText_10 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_SetUsersText_10, &lVal ); }

// Disable_SetUsersText_10 disables SetUsersText.  
#define Disable_SetUsersText_10 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_SetUsersText_10, &lVal ); }

// SetCol_SetUsersText_10( NewCol ) sets the color of control SetUsersText.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_SetUsersText_10( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_SetUsersText_10, lVal ); }


//-------------------------------------------------------------------------------------------

//  UserNameText control (1D - Text)

#define ID_UserNameText_1D 0x0302    

// MaxBytes_UserNameText_1D is maximum storage of UserNameText in bytes
#define MaxBytes_UserNameText_1D 0x000A

// Get_UserNameText_1D( pUChar ) gets UserNameText value.  pUChar must be pointer to unsigned char array, minimum length 10 bytes 
#define Get_UserNameText_1D( pUChar ) GetBytes( STR_ROM01, 0x1E22, pUChar, 10 )

// pUserNameText_1D is an unsigned char ROM pointer which may also be used to get the array (use Set_UserNameText_1D() to set it) 
#define pUserNameText_1D ((rom unsigned char*)0x011E22)

// Set_UserNameText_1D( pRUChar, pUChar ) sets UserNameText value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_UserNameText_1D( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1E22, pRUChar, pUChar, 10 )

// SetUp_UserNameText_1D( pRUChar, pUChar ) sets UserNameText value and automatically updates client if connected 
#define SetUp_UserNameText_1D( pRUChar, pUChar ) { Set_UserNameText_1D( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_UserNameText_1D, 0 ); }

// EnsureVisible_UserNameText_1D scrolls control UserNameText into view on the client.  
#define EnsureVisible_UserNameText_1D { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_UserNameText_1D, &lVal ); }

// Show_UserNameText_1D sets that control UserNameText to visible.  
#define Show_UserNameText_1D { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_UserNameText_1D, &lVal ); }

// Hide_UserNameText_1D sets that control UserNameText to visible.  
#define Hide_UserNameText_1D { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_UserNameText_1D, &lVal ); }

// Enable_UserNameText_1D enables UserNameText.  
#define Enable_UserNameText_1D { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_UserNameText_1D, &lVal ); }

// Disable_UserNameText_1D disables UserNameText.  
#define Disable_UserNameText_1D { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_UserNameText_1D, &lVal ); }

// SetCol_UserNameText_1D( NewCol ) sets the color of control UserNameText.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_UserNameText_1D( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_UserNameText_1D, lVal ); }


//-------------------------------------------------------------------------------------------

//  UserName control (0E - Text)

#define ID_UserName_E 0x0303    

// MaxBytes_UserName_E is maximum storage of UserName in bytes
#define MaxBytes_UserName_E 0x0015

// Get_UserName_E( pUChar ) gets UserName value.  pUChar must be pointer to unsigned char array, minimum length 21 bytes 
#define Get_UserName_E( pUChar ) GetBytes( STR_RAM, 0x002D, pUChar, 21 )

// pUserName_E is an unsigned char RAM pointer which may also be used to set or get the array
#define pUserName_E ((unsigned char*)0x012D)

// Set_UserName_E( pRUChar, pUChar ) sets UserName value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_UserName_E( pRUChar, pUChar ) SetBytes( STR_RAM, 0x002D, pRUChar, pUChar, 21 )

// SetUp_UserName_E( pRUChar, pUChar ) sets UserName value and automatically updates client if connected 
#define SetUp_UserName_E( pRUChar, pUChar ) { Set_UserName_E( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_UserName_E, 0 ); }

// EnsureVisible_UserName_E scrolls control UserName into view on the client.  
#define EnsureVisible_UserName_E { unsigned long lVal = 0x00010010; FxPCommand( FxPC_SetProps, ID_UserName_E, &lVal ); }

// Show_UserName_E sets that control UserName to visible.  
#define Show_UserName_E { unsigned long lVal = 0x00010000; FxPCommand( FxPC_SetProps, ID_UserName_E, &lVal ); }

// Hide_UserName_E sets that control UserName to visible.  
#define Hide_UserName_E { unsigned long lVal = 0x00010001; FxPCommand( FxPC_SetProps, ID_UserName_E, &lVal ); }

// Enable_UserName_E enables UserName.  
#define Enable_UserName_E { unsigned long lVal = 0x00010000; FxPCommand( FxPC_SetProps, ID_UserName_E, &lVal ); }

// Disable_UserName_E disables UserName.  
#define Disable_UserName_E { unsigned long lVal = 0x00010080; FxPCommand( FxPC_SetProps, ID_UserName_E, &lVal ); }

// SetCol_UserName_E( NewCol ) sets the color of control UserName.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_UserName_E( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00010040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_UserName_E, lVal ); }


//-------------------------------------------------------------------------------------------

//  Expiry Settings... control (26 - Button)

#define ID_Expiry_Settings____26 0x0304    

// EnsureVisible_Expiry_Settings____26 scrolls control Expiry Settings... into view on the client.  
#define EnsureVisible_Expiry_Settings____26 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Expiry_Settings____26, &lVal ); }

// Show_Expiry_Settings____26 sets that control Expiry Settings... to visible.  
#define Show_Expiry_Settings____26 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Expiry_Settings____26, &lVal ); }

// Hide_Expiry_Settings____26 sets that control Expiry Settings... to visible.  
#define Hide_Expiry_Settings____26 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Expiry_Settings____26, &lVal ); }

// Enable_Expiry_Settings____26 enables Expiry Settings....  
#define Enable_Expiry_Settings____26 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Expiry_Settings____26, &lVal ); }

// Disable_Expiry_Settings____26 disables Expiry Settings....  
#define Disable_Expiry_Settings____26 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Expiry_Settings____26, &lVal ); }

// SetCol_Expiry_Settings____26( NewCol ) sets the color of control Expiry Settings....  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Expiry_Settings____26( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Expiry_Settings____26, lVal ); }


//-------------------------------------------------------------------------------------------

//  Timed Entry Settings... control (34 - Button)

#define ID_Timed_Entry_Settings____34 0x0305    

// EnsureVisible_Timed_Entry_Settings____34 scrolls control Timed Entry Settings... into view on the client.  
#define EnsureVisible_Timed_Entry_Settings____34 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Timed_Entry_Settings____34, &lVal ); }

// Show_Timed_Entry_Settings____34 sets that control Timed Entry Settings... to visible.  
#define Show_Timed_Entry_Settings____34 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Timed_Entry_Settings____34, &lVal ); }

// Hide_Timed_Entry_Settings____34 sets that control Timed Entry Settings... to visible.  
#define Hide_Timed_Entry_Settings____34 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Timed_Entry_Settings____34, &lVal ); }

// Enable_Timed_Entry_Settings____34 enables Timed Entry Settings....  
#define Enable_Timed_Entry_Settings____34 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Timed_Entry_Settings____34, &lVal ); }

// Disable_Timed_Entry_Settings____34 disables Timed Entry Settings....  
#define Disable_Timed_Entry_Settings____34 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Timed_Entry_Settings____34, &lVal ); }

// SetCol_Timed_Entry_Settings____34( NewCol ) sets the color of control Timed Entry Settings....  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Timed_Entry_Settings____34( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Timed_Entry_Settings____34, lVal ); }


//-------------------------------------------------------------------------------------------

//  BTID control (40 - Text)

#define ID_BTID_40 0x0306    

// MaxBytes_BTID_40 is maximum storage of BTID in bytes
#define MaxBytes_BTID_40 0x0021

// Get_BTID_40( pUChar ) gets BTID value.  pUChar must be pointer to unsigned char array, minimum length 33 bytes 
#define Get_BTID_40( pUChar ) GetBytes( STR_RAM, 0x0042, pUChar, 33 )

// pBTID_40 is an unsigned char RAM pointer which may also be used to set or get the array
#define pBTID_40 ((unsigned char*)0x0142)

// Set_BTID_40( pRUChar, pUChar ) sets BTID value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_BTID_40( pRUChar, pUChar ) SetBytes( STR_RAM, 0x0042, pRUChar, pUChar, 33 )

// SetUp_BTID_40( pRUChar, pUChar ) sets BTID value and automatically updates client if connected 
#define SetUp_BTID_40( pRUChar, pUChar ) { Set_BTID_40( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_BTID_40, 0 ); }

// EnsureVisible_BTID_40 scrolls control BTID into view on the client.  
#define EnsureVisible_BTID_40 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_BTID_40, &lVal ); }

// Show_BTID_40 sets that control BTID to visible.  
#define Show_BTID_40 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_BTID_40, &lVal ); }

// Hide_BTID_40 sets that control BTID to visible.  
#define Hide_BTID_40 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_BTID_40, &lVal ); }

// Enable_BTID_40 enables BTID.  
#define Enable_BTID_40 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_BTID_40, &lVal ); }

// Disable_BTID_40 disables BTID.  
#define Disable_BTID_40 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_BTID_40, &lVal ); }

// SetCol_BTID_40( NewCol ) sets the color of control BTID.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_BTID_40( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_BTID_40, lVal ); }


//-------------------------------------------------------------------------------------------

//  OK control (0B - Button)

#define ID_OK_B 0x0307    

// EnsureVisible_OK_B scrolls control OK into view on the client.  
#define EnsureVisible_OK_B { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_OK_B, &lVal ); }

// Show_OK_B sets that control OK to visible.  
#define Show_OK_B { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_OK_B, &lVal ); }

// Hide_OK_B sets that control OK to visible.  
#define Hide_OK_B { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_OK_B, &lVal ); }

// Enable_OK_B enables OK.  
#define Enable_OK_B { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_OK_B, &lVal ); }

// Disable_OK_B disables OK.  
#define Disable_OK_B { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_OK_B, &lVal ); }

// SetCol_OK_B( NewCol ) sets the color of control OK.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_OK_B( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_OK_B, lVal ); }


//-------------------------------------------------------------------------------------------

//  Cancel control (0F - Button)

#define ID_Cancel_F 0x0308    

// EnsureVisible_Cancel_F scrolls control Cancel into view on the client.  
#define EnsureVisible_Cancel_F { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Cancel_F, &lVal ); }

// Show_Cancel_F sets that control Cancel to visible.  
#define Show_Cancel_F { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Cancel_F, &lVal ); }

// Hide_Cancel_F sets that control Cancel to visible.  
#define Hide_Cancel_F { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Cancel_F, &lVal ); }

// Enable_Cancel_F enables Cancel.  
#define Enable_Cancel_F { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Cancel_F, &lVal ); }

// Disable_Cancel_F disables Cancel.  
#define Disable_Cancel_F { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Cancel_F, &lVal ); }

// SetCol_Cancel_F( NewCol ) sets the color of control Cancel.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Cancel_F( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Cancel_F, lVal ); }


//-------------------------------------------------------------------------------------------

//  ExpiryText control (27 - Text)

#define ID_ExpiryText_27 0x0401    

// MaxBytes_ExpiryText_27 is maximum storage of ExpiryText in bytes
#define MaxBytes_ExpiryText_27 0x0015

// Get_ExpiryText_27( pUChar ) gets ExpiryText value.  pUChar must be pointer to unsigned char array, minimum length 21 bytes 
#define Get_ExpiryText_27( pUChar ) GetBytes( STR_ROM01, 0x1ECA, pUChar, 21 )

// pExpiryText_27 is an unsigned char ROM pointer which may also be used to get the array (use Set_ExpiryText_27() to set it) 
#define pExpiryText_27 ((rom unsigned char*)0x011ECA)

// Set_ExpiryText_27( pRUChar, pUChar ) sets ExpiryText value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_ExpiryText_27( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1ECA, pRUChar, pUChar, 21 )

// SetUp_ExpiryText_27( pRUChar, pUChar ) sets ExpiryText value and automatically updates client if connected 
#define SetUp_ExpiryText_27( pRUChar, pUChar ) { Set_ExpiryText_27( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_ExpiryText_27, 0 ); }

// EnsureVisible_ExpiryText_27 scrolls control ExpiryText into view on the client.  
#define EnsureVisible_ExpiryText_27 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_ExpiryText_27, &lVal ); }

// Show_ExpiryText_27 sets that control ExpiryText to visible.  
#define Show_ExpiryText_27 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_ExpiryText_27, &lVal ); }

// Hide_ExpiryText_27 sets that control ExpiryText to visible.  
#define Hide_ExpiryText_27 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_ExpiryText_27, &lVal ); }

// Enable_ExpiryText_27 enables ExpiryText.  
#define Enable_ExpiryText_27 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_ExpiryText_27, &lVal ); }

// Disable_ExpiryText_27 disables ExpiryText.  
#define Disable_ExpiryText_27 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_ExpiryText_27, &lVal ); }

// SetCol_ExpiryText_27( NewCol ) sets the color of control ExpiryText.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_ExpiryText_27( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_ExpiryText_27, lVal ); }


//-------------------------------------------------------------------------------------------

//  DelDateText control (36 - Text)

#define ID_DelDateText_36 0x0402    

// MaxBytes_DelDateText_36 is maximum storage of DelDateText in bytes
#define MaxBytes_DelDateText_36 0x0010

// Get_DelDateText_36( pUChar ) gets DelDateText value.  pUChar must be pointer to unsigned char array, minimum length 16 bytes 
#define Get_DelDateText_36( pUChar ) GetBytes( STR_ROM01, 0x1D14, pUChar, 16 )

// pDelDateText_36 is an unsigned char ROM pointer which may also be used to get the array (use Set_DelDateText_36() to set it) 
#define pDelDateText_36 ((rom unsigned char*)0x011D14)

// Set_DelDateText_36( pRUChar, pUChar ) sets DelDateText value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_DelDateText_36( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1D14, pRUChar, pUChar, 16 )

// SetUp_DelDateText_36( pRUChar, pUChar ) sets DelDateText value and automatically updates client if connected 
#define SetUp_DelDateText_36( pRUChar, pUChar ) { Set_DelDateText_36( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_DelDateText_36, 0 ); }

// EnsureVisible_DelDateText_36 scrolls control DelDateText into view on the client.  
#define EnsureVisible_DelDateText_36 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_DelDateText_36, &lVal ); }

// Show_DelDateText_36 sets that control DelDateText to visible.  
#define Show_DelDateText_36 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_DelDateText_36, &lVal ); }

// Hide_DelDateText_36 sets that control DelDateText to visible.  
#define Hide_DelDateText_36 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_DelDateText_36, &lVal ); }

// Enable_DelDateText_36 enables DelDateText.  
#define Enable_DelDateText_36 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_DelDateText_36, &lVal ); }

// Disable_DelDateText_36 disables DelDateText.  
#define Disable_DelDateText_36 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_DelDateText_36, &lVal ); }

// SetCol_DelDateText_36( NewCol ) sets the color of control DelDateText.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_DelDateText_36( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_DelDateText_36, lVal ); }


//-------------------------------------------------------------------------------------------

//  DeletionDate control (37 - DateTime)

#define ID_DeletionDate_37 0x0403    

// Get_DeletionDate_37( pDT ) gets DeletionDate value.  pDT must be pointer to DateTimeU struct as defined in ToothPIC.h
#define Get_DeletionDate_37( pDT ) GetBytes( STR_RAM, 0x000C, pDT, sizeof(DateTimeU) )

// pDeletionDate_37 is a DateTimeU RAM pointer which may also be used to set or get the value
#define pDeletionDate_37 ((DateTimeU*)0x010C)

// Set_DeletionDate_37( pRDT, pDT ) sets DeletionDate value.  pRDT must be rom pointer to DateTimeU struct or pDT must 
// be pointer to DateTimeU struct, the other pointer must be zero
#define Set_DeletionDate_37( pRDT, pDT ) SetBytes( STR_RAM, 0x000C, pRDT, pDT, sizeof(DateTimeU) )

// SetUp_DeletionDate_37( pRUChar, pUChar ) sets DeletionDate value and automatically updates client if connected 
#define SetUp_DeletionDate_37( pRUChar, pUChar ) { Set_DeletionDate_37( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_DeletionDate_37, 0 ); }

// EnsureVisible_DeletionDate_37 scrolls control DeletionDate into view on the client.  
#define EnsureVisible_DeletionDate_37 { unsigned long lVal = 0x00EF0010; FxPCommand( FxPC_SetProps, ID_DeletionDate_37, &lVal ); }

// Show_DeletionDate_37 sets that control DeletionDate to visible.  
#define Show_DeletionDate_37 { unsigned long lVal = 0x00EF0000; FxPCommand( FxPC_SetProps, ID_DeletionDate_37, &lVal ); }

// Hide_DeletionDate_37 sets that control DeletionDate to visible.  
#define Hide_DeletionDate_37 { unsigned long lVal = 0x00EF0001; FxPCommand( FxPC_SetProps, ID_DeletionDate_37, &lVal ); }

// Enable_DeletionDate_37 enables DeletionDate.  
#define Enable_DeletionDate_37 { unsigned long lVal = 0x00EF0000; FxPCommand( FxPC_SetProps, ID_DeletionDate_37, &lVal ); }

// Disable_DeletionDate_37 disables DeletionDate.  
#define Disable_DeletionDate_37 { unsigned long lVal = 0x00EF0080; FxPCommand( FxPC_SetProps, ID_DeletionDate_37, &lVal ); }

// SetCol_DeletionDate_37( NewCol ) sets the color of control DeletionDate.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_DeletionDate_37( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00EF0040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_DeletionDate_37, lVal ); }


//-------------------------------------------------------------------------------------------

//  Close control (38 - Button)

#define ID_Close_38 0x0404    

// EnsureVisible_Close_38 scrolls control Close into view on the client.  
#define EnsureVisible_Close_38 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Close_38, &lVal ); }

// Show_Close_38 sets that control Close to visible.  
#define Show_Close_38 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Close_38, &lVal ); }

// Hide_Close_38 sets that control Close to visible.  
#define Hide_Close_38 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Close_38, &lVal ); }

// Enable_Close_38 enables Close.  
#define Enable_Close_38 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Close_38, &lVal ); }

// Disable_Close_38 disables Close.  
#define Disable_Close_38 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Close_38, &lVal ); }

// SetCol_Close_38( NewCol ) sets the color of control Close.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Close_38( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Close_38, lVal ); }


//-------------------------------------------------------------------------------------------

//  TimedEntryText control (35 - Text)

#define ID_TimedEntryText_35 0x0501    

// MaxBytes_TimedEntryText_35 is maximum storage of TimedEntryText in bytes
#define MaxBytes_TimedEntryText_35 0x0015

// Get_TimedEntryText_35( pUChar ) gets TimedEntryText value.  pUChar must be pointer to unsigned char array, minimum length 21 bytes 
#define Get_TimedEntryText_35( pUChar ) GetBytes( STR_ROM01, 0x1EE0, pUChar, 21 )

// pTimedEntryText_35 is an unsigned char ROM pointer which may also be used to get the array (use Set_TimedEntryText_35() to set it) 
#define pTimedEntryText_35 ((rom unsigned char*)0x011EE0)

// Set_TimedEntryText_35( pRUChar, pUChar ) sets TimedEntryText value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_TimedEntryText_35( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1EE0, pRUChar, pUChar, 21 )

// SetUp_TimedEntryText_35( pRUChar, pUChar ) sets TimedEntryText value and automatically updates client if connected 
#define SetUp_TimedEntryText_35( pRUChar, pUChar ) { Set_TimedEntryText_35( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_TimedEntryText_35, 0 ); }

// EnsureVisible_TimedEntryText_35 scrolls control TimedEntryText into view on the client.  
#define EnsureVisible_TimedEntryText_35 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_TimedEntryText_35, &lVal ); }

// Show_TimedEntryText_35 sets that control TimedEntryText to visible.  
#define Show_TimedEntryText_35 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_TimedEntryText_35, &lVal ); }

// Hide_TimedEntryText_35 sets that control TimedEntryText to visible.  
#define Hide_TimedEntryText_35 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_TimedEntryText_35, &lVal ); }

// Enable_TimedEntryText_35 enables TimedEntryText.  
#define Enable_TimedEntryText_35 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_TimedEntryText_35, &lVal ); }

// Disable_TimedEntryText_35 disables TimedEntryText.  
#define Disable_TimedEntryText_35 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_TimedEntryText_35, &lVal ); }

// SetCol_TimedEntryText_35( NewCol ) sets the color of control TimedEntryText.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_TimedEntryText_35( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_TimedEntryText_35, lVal ); }


//-------------------------------------------------------------------------------------------

//  From control (28 - Text)

#define ID_From_28 0x0502    

// MaxBytes_From_28 is maximum storage of From in bytes
#define MaxBytes_From_28 0x0010

// Get_From_28( pUChar ) gets From value.  pUChar must be pointer to unsigned char array, minimum length 16 bytes 
#define Get_From_28( pUChar ) GetBytes( STR_ROM01, 0x1D24, pUChar, 16 )

// pFrom_28 is an unsigned char ROM pointer which may also be used to get the array (use Set_From_28() to set it) 
#define pFrom_28 ((rom unsigned char*)0x011D24)

// Set_From_28( pRUChar, pUChar ) sets From value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_From_28( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1D24, pRUChar, pUChar, 16 )

// SetUp_From_28( pRUChar, pUChar ) sets From value and automatically updates client if connected 
#define SetUp_From_28( pRUChar, pUChar ) { Set_From_28( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_From_28, 0 ); }

// EnsureVisible_From_28 scrolls control From into view on the client.  
#define EnsureVisible_From_28 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_From_28, &lVal ); }

// Show_From_28 sets that control From to visible.  
#define Show_From_28 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_From_28, &lVal ); }

// Hide_From_28 sets that control From to visible.  
#define Hide_From_28 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_From_28, &lVal ); }

// Enable_From_28 enables From.  
#define Enable_From_28 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_From_28, &lVal ); }

// Disable_From_28 disables From.  
#define Disable_From_28 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_From_28, &lVal ); }

// SetCol_From_28( NewCol ) sets the color of control From.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_From_28( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_From_28, lVal ); }


//-------------------------------------------------------------------------------------------

//  FromTime control (29 - DateTime)

#define ID_FromTime_29 0x0503    

// Get_FromTime_29( pDT ) gets FromTime value.  pDT must be pointer to DateTimeU struct as defined in ToothPIC.h
#define Get_FromTime_29( pDT ) GetBytes( STR_RAM, 0x0014, pDT, sizeof(DateTimeU) )

// pFromTime_29 is a DateTimeU RAM pointer which may also be used to set or get the value
#define pFromTime_29 ((DateTimeU*)0x0114)

// Set_FromTime_29( pRDT, pDT ) sets FromTime value.  pRDT must be rom pointer to DateTimeU struct or pDT must 
// be pointer to DateTimeU struct, the other pointer must be zero
#define Set_FromTime_29( pRDT, pDT ) SetBytes( STR_RAM, 0x0014, pRDT, pDT, sizeof(DateTimeU) )

// SetUp_FromTime_29( pRUChar, pUChar ) sets FromTime value and automatically updates client if connected 
#define SetUp_FromTime_29( pRUChar, pUChar ) { Set_FromTime_29( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_FromTime_29, 0 ); }

// EnsureVisible_FromTime_29 scrolls control FromTime into view on the client.  
#define EnsureVisible_FromTime_29 { unsigned long lVal = 0x000F0010; FxPCommand( FxPC_SetProps, ID_FromTime_29, &lVal ); }

// Show_FromTime_29 sets that control FromTime to visible.  
#define Show_FromTime_29 { unsigned long lVal = 0x000F0000; FxPCommand( FxPC_SetProps, ID_FromTime_29, &lVal ); }

// Hide_FromTime_29 sets that control FromTime to visible.  
#define Hide_FromTime_29 { unsigned long lVal = 0x000F0001; FxPCommand( FxPC_SetProps, ID_FromTime_29, &lVal ); }

// Enable_FromTime_29 enables FromTime.  
#define Enable_FromTime_29 { unsigned long lVal = 0x000F0000; FxPCommand( FxPC_SetProps, ID_FromTime_29, &lVal ); }

// Disable_FromTime_29 disables FromTime.  
#define Disable_FromTime_29 { unsigned long lVal = 0x000F0080; FxPCommand( FxPC_SetProps, ID_FromTime_29, &lVal ); }

// SetCol_FromTime_29( NewCol ) sets the color of control FromTime.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_FromTime_29( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x000F0040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_FromTime_29, lVal ); }


//-------------------------------------------------------------------------------------------

//  To control (2A - Text)

#define ID_To_2A 0x0504    

// MaxBytes_To_2A is maximum storage of To in bytes
#define MaxBytes_To_2A 0x0010

// Get_To_2A( pUChar ) gets To value.  pUChar must be pointer to unsigned char array, minimum length 16 bytes 
#define Get_To_2A( pUChar ) GetBytes( STR_ROM01, 0x1D34, pUChar, 16 )

// pTo_2A is an unsigned char ROM pointer which may also be used to get the array (use Set_To_2A() to set it) 
#define pTo_2A ((rom unsigned char*)0x011D34)

// Set_To_2A( pRUChar, pUChar ) sets To value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_To_2A( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1D34, pRUChar, pUChar, 16 )

// SetUp_To_2A( pRUChar, pUChar ) sets To value and automatically updates client if connected 
#define SetUp_To_2A( pRUChar, pUChar ) { Set_To_2A( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_To_2A, 0 ); }

// EnsureVisible_To_2A scrolls control To into view on the client.  
#define EnsureVisible_To_2A { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_To_2A, &lVal ); }

// Show_To_2A sets that control To to visible.  
#define Show_To_2A { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_To_2A, &lVal ); }

// Hide_To_2A sets that control To to visible.  
#define Hide_To_2A { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_To_2A, &lVal ); }

// Enable_To_2A enables To.  
#define Enable_To_2A { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_To_2A, &lVal ); }

// Disable_To_2A disables To.  
#define Disable_To_2A { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_To_2A, &lVal ); }

// SetCol_To_2A( NewCol ) sets the color of control To.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_To_2A( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_To_2A, lVal ); }


//-------------------------------------------------------------------------------------------

//  ToTime control (2B - DateTime)

#define ID_ToTime_2B 0x0505    

// Get_ToTime_2B( pDT ) gets ToTime value.  pDT must be pointer to DateTimeU struct as defined in ToothPIC.h
#define Get_ToTime_2B( pDT ) GetBytes( STR_RAM, 0x001C, pDT, sizeof(DateTimeU) )

// pToTime_2B is a DateTimeU RAM pointer which may also be used to set or get the value
#define pToTime_2B ((DateTimeU*)0x011C)

// Set_ToTime_2B( pRDT, pDT ) sets ToTime value.  pRDT must be rom pointer to DateTimeU struct or pDT must 
// be pointer to DateTimeU struct, the other pointer must be zero
#define Set_ToTime_2B( pRDT, pDT ) SetBytes( STR_RAM, 0x001C, pRDT, pDT, sizeof(DateTimeU) )

// SetUp_ToTime_2B( pRUChar, pUChar ) sets ToTime value and automatically updates client if connected 
#define SetUp_ToTime_2B( pRUChar, pUChar ) { Set_ToTime_2B( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_ToTime_2B, 0 ); }

// EnsureVisible_ToTime_2B scrolls control ToTime into view on the client.  
#define EnsureVisible_ToTime_2B { unsigned long lVal = 0x000F0010; FxPCommand( FxPC_SetProps, ID_ToTime_2B, &lVal ); }

// Show_ToTime_2B sets that control ToTime to visible.  
#define Show_ToTime_2B { unsigned long lVal = 0x000F0000; FxPCommand( FxPC_SetProps, ID_ToTime_2B, &lVal ); }

// Hide_ToTime_2B sets that control ToTime to visible.  
#define Hide_ToTime_2B { unsigned long lVal = 0x000F0001; FxPCommand( FxPC_SetProps, ID_ToTime_2B, &lVal ); }

// Enable_ToTime_2B enables ToTime.  
#define Enable_ToTime_2B { unsigned long lVal = 0x000F0000; FxPCommand( FxPC_SetProps, ID_ToTime_2B, &lVal ); }

// Disable_ToTime_2B disables ToTime.  
#define Disable_ToTime_2B { unsigned long lVal = 0x000F0080; FxPCommand( FxPC_SetProps, ID_ToTime_2B, &lVal ); }

// SetCol_ToTime_2B( NewCol ) sets the color of control ToTime.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_ToTime_2B( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x000F0040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_ToTime_2B, lVal ); }


//-------------------------------------------------------------------------------------------

//  Monday control (2C - Latch)

#define ID_Monday_2C 0x0506    

// Latch values are 0xFF for On and 0x00 for Off
// Get_Monday_2C( pUChar ) gets Monday value.  pUChar must be pointer to unsigned char
#define Get_Monday_2C( pUChar ) GetBytes( STR_RAM, 0x0063, pUChar, sizeof(unsigned char) )

// pMonday_2C is an unsigned char RAM pointer which may also be used to set or get the value
#define pMonday_2C ((unsigned char*)0x0163)

// Set_Monday_2C( pRUChar, pUChar ) sets Monday value.  pRUChar must be rom pointer to unsigned char or pUChar must 
// be pointer to unsigned char, the other pointer must be zero
#define Set_Monday_2C( pRUChar, pUChar ) SetBytes( STR_RAM, 0x0063, pRUChar, pUChar, sizeof(unsigned char) )

// SetUp_Monday_2C( pRUChar, pUChar ) sets Monday value and automatically updates client if connected 
#define SetUp_Monday_2C( pRUChar, pUChar ) { Set_Monday_2C( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_Monday_2C, 0 ); }

// EnsureVisible_Monday_2C scrolls control Monday into view on the client.  
#define EnsureVisible_Monday_2C { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Monday_2C, &lVal ); }

// Show_Monday_2C sets that control Monday to visible.  
#define Show_Monday_2C { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Monday_2C, &lVal ); }

// Hide_Monday_2C sets that control Monday to visible.  
#define Hide_Monday_2C { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Monday_2C, &lVal ); }

// Enable_Monday_2C enables Monday.  
#define Enable_Monday_2C { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Monday_2C, &lVal ); }

// Disable_Monday_2C disables Monday.  
#define Disable_Monday_2C { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Monday_2C, &lVal ); }

// SetCol_Monday_2C( NewCol ) sets the color of control Monday.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Monday_2C( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Monday_2C, lVal ); }


//-------------------------------------------------------------------------------------------

//  Tuesday control (2D - Latch)

#define ID_Tuesday_2D 0x0507    

// Latch values are 0xFF for On and 0x00 for Off
// Get_Tuesday_2D( pUChar ) gets Tuesday value.  pUChar must be pointer to unsigned char
#define Get_Tuesday_2D( pUChar ) GetBytes( STR_RAM, 0x0064, pUChar, sizeof(unsigned char) )

// pTuesday_2D is an unsigned char RAM pointer which may also be used to set or get the value
#define pTuesday_2D ((unsigned char*)0x0164)

// Set_Tuesday_2D( pRUChar, pUChar ) sets Tuesday value.  pRUChar must be rom pointer to unsigned char or pUChar must 
// be pointer to unsigned char, the other pointer must be zero
#define Set_Tuesday_2D( pRUChar, pUChar ) SetBytes( STR_RAM, 0x0064, pRUChar, pUChar, sizeof(unsigned char) )

// SetUp_Tuesday_2D( pRUChar, pUChar ) sets Tuesday value and automatically updates client if connected 
#define SetUp_Tuesday_2D( pRUChar, pUChar ) { Set_Tuesday_2D( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_Tuesday_2D, 0 ); }

// EnsureVisible_Tuesday_2D scrolls control Tuesday into view on the client.  
#define EnsureVisible_Tuesday_2D { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Tuesday_2D, &lVal ); }

// Show_Tuesday_2D sets that control Tuesday to visible.  
#define Show_Tuesday_2D { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Tuesday_2D, &lVal ); }

// Hide_Tuesday_2D sets that control Tuesday to visible.  
#define Hide_Tuesday_2D { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Tuesday_2D, &lVal ); }

// Enable_Tuesday_2D enables Tuesday.  
#define Enable_Tuesday_2D { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Tuesday_2D, &lVal ); }

// Disable_Tuesday_2D disables Tuesday.  
#define Disable_Tuesday_2D { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Tuesday_2D, &lVal ); }

// SetCol_Tuesday_2D( NewCol ) sets the color of control Tuesday.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Tuesday_2D( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Tuesday_2D, lVal ); }


//-------------------------------------------------------------------------------------------

//  Wednesday control (2E - Latch)

#define ID_Wednesday_2E 0x0508    

// Latch values are 0xFF for On and 0x00 for Off
// Get_Wednesday_2E( pUChar ) gets Wednesday value.  pUChar must be pointer to unsigned char
#define Get_Wednesday_2E( pUChar ) GetBytes( STR_RAM, 0x0065, pUChar, sizeof(unsigned char) )

// pWednesday_2E is an unsigned char RAM pointer which may also be used to set or get the value
#define pWednesday_2E ((unsigned char*)0x0165)

// Set_Wednesday_2E( pRUChar, pUChar ) sets Wednesday value.  pRUChar must be rom pointer to unsigned char or pUChar must 
// be pointer to unsigned char, the other pointer must be zero
#define Set_Wednesday_2E( pRUChar, pUChar ) SetBytes( STR_RAM, 0x0065, pRUChar, pUChar, sizeof(unsigned char) )

// SetUp_Wednesday_2E( pRUChar, pUChar ) sets Wednesday value and automatically updates client if connected 
#define SetUp_Wednesday_2E( pRUChar, pUChar ) { Set_Wednesday_2E( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_Wednesday_2E, 0 ); }

// EnsureVisible_Wednesday_2E scrolls control Wednesday into view on the client.  
#define EnsureVisible_Wednesday_2E { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Wednesday_2E, &lVal ); }

// Show_Wednesday_2E sets that control Wednesday to visible.  
#define Show_Wednesday_2E { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Wednesday_2E, &lVal ); }

// Hide_Wednesday_2E sets that control Wednesday to visible.  
#define Hide_Wednesday_2E { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Wednesday_2E, &lVal ); }

// Enable_Wednesday_2E enables Wednesday.  
#define Enable_Wednesday_2E { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Wednesday_2E, &lVal ); }

// Disable_Wednesday_2E disables Wednesday.  
#define Disable_Wednesday_2E { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Wednesday_2E, &lVal ); }

// SetCol_Wednesday_2E( NewCol ) sets the color of control Wednesday.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Wednesday_2E( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Wednesday_2E, lVal ); }


//-------------------------------------------------------------------------------------------

//  Thursday control (2F - Latch)

#define ID_Thursday_2F 0x0509    

// Latch values are 0xFF for On and 0x00 for Off
// Get_Thursday_2F( pUChar ) gets Thursday value.  pUChar must be pointer to unsigned char
#define Get_Thursday_2F( pUChar ) GetBytes( STR_RAM, 0x0066, pUChar, sizeof(unsigned char) )

// pThursday_2F is an unsigned char RAM pointer which may also be used to set or get the value
#define pThursday_2F ((unsigned char*)0x0166)

// Set_Thursday_2F( pRUChar, pUChar ) sets Thursday value.  pRUChar must be rom pointer to unsigned char or pUChar must 
// be pointer to unsigned char, the other pointer must be zero
#define Set_Thursday_2F( pRUChar, pUChar ) SetBytes( STR_RAM, 0x0066, pRUChar, pUChar, sizeof(unsigned char) )

// SetUp_Thursday_2F( pRUChar, pUChar ) sets Thursday value and automatically updates client if connected 
#define SetUp_Thursday_2F( pRUChar, pUChar ) { Set_Thursday_2F( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_Thursday_2F, 0 ); }

// EnsureVisible_Thursday_2F scrolls control Thursday into view on the client.  
#define EnsureVisible_Thursday_2F { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Thursday_2F, &lVal ); }

// Show_Thursday_2F sets that control Thursday to visible.  
#define Show_Thursday_2F { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Thursday_2F, &lVal ); }

// Hide_Thursday_2F sets that control Thursday to visible.  
#define Hide_Thursday_2F { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Thursday_2F, &lVal ); }

// Enable_Thursday_2F enables Thursday.  
#define Enable_Thursday_2F { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Thursday_2F, &lVal ); }

// Disable_Thursday_2F disables Thursday.  
#define Disable_Thursday_2F { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Thursday_2F, &lVal ); }

// SetCol_Thursday_2F( NewCol ) sets the color of control Thursday.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Thursday_2F( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Thursday_2F, lVal ); }


//-------------------------------------------------------------------------------------------

//  Friday control (30 - Latch)

#define ID_Friday_30 0x050A    

// Latch values are 0xFF for On and 0x00 for Off
// Get_Friday_30( pUChar ) gets Friday value.  pUChar must be pointer to unsigned char
#define Get_Friday_30( pUChar ) GetBytes( STR_RAM, 0x0067, pUChar, sizeof(unsigned char) )

// pFriday_30 is an unsigned char RAM pointer which may also be used to set or get the value
#define pFriday_30 ((unsigned char*)0x0167)

// Set_Friday_30( pRUChar, pUChar ) sets Friday value.  pRUChar must be rom pointer to unsigned char or pUChar must 
// be pointer to unsigned char, the other pointer must be zero
#define Set_Friday_30( pRUChar, pUChar ) SetBytes( STR_RAM, 0x0067, pRUChar, pUChar, sizeof(unsigned char) )

// SetUp_Friday_30( pRUChar, pUChar ) sets Friday value and automatically updates client if connected 
#define SetUp_Friday_30( pRUChar, pUChar ) { Set_Friday_30( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_Friday_30, 0 ); }

// EnsureVisible_Friday_30 scrolls control Friday into view on the client.  
#define EnsureVisible_Friday_30 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Friday_30, &lVal ); }

// Show_Friday_30 sets that control Friday to visible.  
#define Show_Friday_30 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Friday_30, &lVal ); }

// Hide_Friday_30 sets that control Friday to visible.  
#define Hide_Friday_30 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Friday_30, &lVal ); }

// Enable_Friday_30 enables Friday.  
#define Enable_Friday_30 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Friday_30, &lVal ); }

// Disable_Friday_30 disables Friday.  
#define Disable_Friday_30 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Friday_30, &lVal ); }

// SetCol_Friday_30( NewCol ) sets the color of control Friday.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Friday_30( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Friday_30, lVal ); }


//-------------------------------------------------------------------------------------------

//  Saturday control (31 - Latch)

#define ID_Saturday_31 0x050B    

// Latch values are 0xFF for On and 0x00 for Off
// Get_Saturday_31( pUChar ) gets Saturday value.  pUChar must be pointer to unsigned char
#define Get_Saturday_31( pUChar ) GetBytes( STR_RAM, 0x0068, pUChar, sizeof(unsigned char) )

// pSaturday_31 is an unsigned char RAM pointer which may also be used to set or get the value
#define pSaturday_31 ((unsigned char*)0x0168)

// Set_Saturday_31( pRUChar, pUChar ) sets Saturday value.  pRUChar must be rom pointer to unsigned char or pUChar must 
// be pointer to unsigned char, the other pointer must be zero
#define Set_Saturday_31( pRUChar, pUChar ) SetBytes( STR_RAM, 0x0068, pRUChar, pUChar, sizeof(unsigned char) )

// SetUp_Saturday_31( pRUChar, pUChar ) sets Saturday value and automatically updates client if connected 
#define SetUp_Saturday_31( pRUChar, pUChar ) { Set_Saturday_31( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_Saturday_31, 0 ); }

// EnsureVisible_Saturday_31 scrolls control Saturday into view on the client.  
#define EnsureVisible_Saturday_31 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Saturday_31, &lVal ); }

// Show_Saturday_31 sets that control Saturday to visible.  
#define Show_Saturday_31 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Saturday_31, &lVal ); }

// Hide_Saturday_31 sets that control Saturday to visible.  
#define Hide_Saturday_31 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Saturday_31, &lVal ); }

// Enable_Saturday_31 enables Saturday.  
#define Enable_Saturday_31 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Saturday_31, &lVal ); }

// Disable_Saturday_31 disables Saturday.  
#define Disable_Saturday_31 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Saturday_31, &lVal ); }

// SetCol_Saturday_31( NewCol ) sets the color of control Saturday.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Saturday_31( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Saturday_31, lVal ); }


//-------------------------------------------------------------------------------------------

//  Sunday control (32 - Latch)

#define ID_Sunday_32 0x050C    

// Latch values are 0xFF for On and 0x00 for Off
// Get_Sunday_32( pUChar ) gets Sunday value.  pUChar must be pointer to unsigned char
#define Get_Sunday_32( pUChar ) GetBytes( STR_RAM, 0x0069, pUChar, sizeof(unsigned char) )

// pSunday_32 is an unsigned char RAM pointer which may also be used to set or get the value
#define pSunday_32 ((unsigned char*)0x0169)

// Set_Sunday_32( pRUChar, pUChar ) sets Sunday value.  pRUChar must be rom pointer to unsigned char or pUChar must 
// be pointer to unsigned char, the other pointer must be zero
#define Set_Sunday_32( pRUChar, pUChar ) SetBytes( STR_RAM, 0x0069, pRUChar, pUChar, sizeof(unsigned char) )

// SetUp_Sunday_32( pRUChar, pUChar ) sets Sunday value and automatically updates client if connected 
#define SetUp_Sunday_32( pRUChar, pUChar ) { Set_Sunday_32( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_Sunday_32, 0 ); }

// EnsureVisible_Sunday_32 scrolls control Sunday into view on the client.  
#define EnsureVisible_Sunday_32 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Sunday_32, &lVal ); }

// Show_Sunday_32 sets that control Sunday to visible.  
#define Show_Sunday_32 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Sunday_32, &lVal ); }

// Hide_Sunday_32 sets that control Sunday to visible.  
#define Hide_Sunday_32 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Sunday_32, &lVal ); }

// Enable_Sunday_32 enables Sunday.  
#define Enable_Sunday_32 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Sunday_32, &lVal ); }

// Disable_Sunday_32 disables Sunday.  
#define Disable_Sunday_32 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Sunday_32, &lVal ); }

// SetCol_Sunday_32( NewCol ) sets the color of control Sunday.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Sunday_32( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Sunday_32, lVal ); }


//-------------------------------------------------------------------------------------------

//  Close control (33 - Button)

#define ID_Close_33 0x050D    

// EnsureVisible_Close_33 scrolls control Close into view on the client.  
#define EnsureVisible_Close_33 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Close_33, &lVal ); }

// Show_Close_33 sets that control Close to visible.  
#define Show_Close_33 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Close_33, &lVal ); }

// Hide_Close_33 sets that control Close to visible.  
#define Hide_Close_33 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Close_33, &lVal ); }

// Enable_Close_33 enables Close.  
#define Enable_Close_33 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Close_33, &lVal ); }

// Disable_Close_33 disables Close.  
#define Disable_Close_33 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Close_33, &lVal ); }

// SetCol_Close_33( NewCol ) sets the color of control Close.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Close_33( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Close_33, lVal ); }


//-------------------------------------------------------------------------------------------

//  Settings control (12 - Text)

#define ID_Settings_12 0x0601    

// MaxBytes_Settings_12 is maximum storage of Settings in bytes
#define MaxBytes_Settings_12 0x0009

// Get_Settings_12( pUChar ) gets Settings value.  pUChar must be pointer to unsigned char array, minimum length 9 bytes 
#define Get_Settings_12( pUChar ) GetBytes( STR_ROM01, 0x1EF6, pUChar, 9 )

// pSettings_12 is an unsigned char ROM pointer which may also be used to get the array (use Set_Settings_12() to set it) 
#define pSettings_12 ((rom unsigned char*)0x011EF6)

// Set_Settings_12( pRUChar, pUChar ) sets Settings value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_Settings_12( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1EF6, pRUChar, pUChar, 9 )

// SetUp_Settings_12( pRUChar, pUChar ) sets Settings value and automatically updates client if connected 
#define SetUp_Settings_12( pRUChar, pUChar ) { Set_Settings_12( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_Settings_12, 0 ); }

// EnsureVisible_Settings_12 scrolls control Settings into view on the client.  
#define EnsureVisible_Settings_12 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Settings_12, &lVal ); }

// Show_Settings_12 sets that control Settings to visible.  
#define Show_Settings_12 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Settings_12, &lVal ); }

// Hide_Settings_12 sets that control Settings to visible.  
#define Hide_Settings_12 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Settings_12, &lVal ); }

// Enable_Settings_12 enables Settings.  
#define Enable_Settings_12 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Settings_12, &lVal ); }

// Disable_Settings_12 disables Settings.  
#define Disable_Settings_12 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Settings_12, &lVal ); }

// SetCol_Settings_12( NewCol ) sets the color of control Settings.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Settings_12( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Settings_12, lVal ); }


//-------------------------------------------------------------------------------------------

//  TriggerList control (16 - List)

#define ID_TriggerList_16 0x0602    

// Get_TriggerList_16( pLong ) gets TriggerList value.  pLong must be pointer to 4-byte signed integer
// if the value could fit into a short or char, you could get fewer bytes 
#define Get_TriggerList_16( pLong ) GetBytes( STR_ROM01, 0x1D44, pLong, sizeof(long) )

// pTriggerList_16 is an unsigned long ROM pointer which may also be used to get the value (use Set_TriggerList_16() to set the value) 
#define pTriggerList_16 ((rom unsigned long*)0x011D44)

// psTriggerList_16 is an unsigned short ROM pointer which may also be used to get the value if it is in the range 0 to 65535
#define psTriggerList_16 ((rom unsigned short*)0x011D44)

// pcTriggerList_16 is an unsigned char ROM pointer which may also be used to get the value if it is in the range 0 to 255
#define pcTriggerList_16 ((rom unsigned char*)0x011D44)

// Set_TriggerList_16( pRLong, pLong ) sets TriggerList value.  pRULong must be rom pointer to 4-byte signed integer or pULong must 
// be pointer to 4-byte signed integer, the other pointer must be zero
// if the value could fit into a short or char, you could set fewer bytes 
#define Set_TriggerList_16( pRLong, pULong ) SetBytes( STR_ROM01, 0x1D44, pRULong, pULong, sizeof(long) )

// SetUp_TriggerList_16( pRLong, pLong ) sets TriggerList value and automatically updates client if connected 
#define SetUp_TriggerList_16( pRLong, pLong ) { Set_TriggerList_16( pRLong, pLong ); FxPCommand( FxPC_CtlUpdate, ID_TriggerList_16, 0 ); }

// NumItem_TriggerList_16 is the number of items in the list 
#define NumItem_TriggerList_16 6

// SetListText_TriggerList_16 / SetListCount_TriggerList_16 define the contents of the list.
// If you need to modify the list items you may do so but you should then
// retransmit the dialog (i.e. call FxPC_SetDialog) to update the client.
// The items should be sequential, each separated from the next with a zero terminator,
// and the storage area originally allocated (ItemTextMaxBytes_TriggerList_16) should never
// be exceeded.  Call SetListCount_$s if you modify the number of items,
#define ListTextLoc_TriggerList_16 0x48CC
#define ListTextStr_TriggerList_16 STR_ROM01
#define SetListText_TriggerList_16( pRUStr, pUStr ) SetBytes( ListTextStr_TriggerList_16, ListTextLoc_TriggerList_16, pRUStr, pUStr, ItemTextMaxBytes_TriggerList_16 )
#define ListNumLoc_TriggerList_16 0x48C4
#define ListNumStr_TriggerList_16 STR_ROM01
#define SetListNum_TriggerList_16( pRUStr, pUStr ) SetBytes( ListNumStr_TriggerList_16, ListNumLoc_TriggerList_16, pRUStr, pUStr, sizeof( long ) )
#define ItemTextMaxBytes_TriggerList_16 0x00BC

// EnsureVisible_TriggerList_16 scrolls control TriggerList into view on the client.  
#define EnsureVisible_TriggerList_16 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_TriggerList_16, &lVal ); }

// Show_TriggerList_16 sets that control TriggerList to visible.  
#define Show_TriggerList_16 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_TriggerList_16, &lVal ); }

// Hide_TriggerList_16 sets that control TriggerList to visible.  
#define Hide_TriggerList_16 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_TriggerList_16, &lVal ); }

// Enable_TriggerList_16 enables TriggerList.  
#define Enable_TriggerList_16 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_TriggerList_16, &lVal ); }

// Disable_TriggerList_16 disables TriggerList.  
#define Disable_TriggerList_16 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_TriggerList_16, &lVal ); }

// SetCol_TriggerList_16( NewCol ) sets the color of control TriggerList.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_TriggerList_16( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_TriggerList_16, lVal ); }


//-------------------------------------------------------------------------------------------

//  LogStyle control (18 - List)

#define ID_LogStyle_18 0x0603    

// Get_LogStyle_18( pLong ) gets LogStyle value.  pLong must be pointer to 4-byte signed integer
// if the value could fit into a short or char, you could get fewer bytes 
#define Get_LogStyle_18( pLong ) GetBytes( STR_ROM01, 0x1D48, pLong, sizeof(long) )

// pLogStyle_18 is an unsigned long ROM pointer which may also be used to get the value (use Set_LogStyle_18() to set the value) 
#define pLogStyle_18 ((rom unsigned long*)0x011D48)

// psLogStyle_18 is an unsigned short ROM pointer which may also be used to get the value if it is in the range 0 to 65535
#define psLogStyle_18 ((rom unsigned short*)0x011D48)

// pcLogStyle_18 is an unsigned char ROM pointer which may also be used to get the value if it is in the range 0 to 255
#define pcLogStyle_18 ((rom unsigned char*)0x011D48)

// Set_LogStyle_18( pRLong, pLong ) sets LogStyle value.  pRULong must be rom pointer to 4-byte signed integer or pULong must 
// be pointer to 4-byte signed integer, the other pointer must be zero
// if the value could fit into a short or char, you could set fewer bytes 
#define Set_LogStyle_18( pRLong, pULong ) SetBytes( STR_ROM01, 0x1D48, pRULong, pULong, sizeof(long) )

// SetUp_LogStyle_18( pRLong, pLong ) sets LogStyle value and automatically updates client if connected 
#define SetUp_LogStyle_18( pRLong, pLong ) { Set_LogStyle_18( pRLong, pLong ); FxPCommand( FxPC_CtlUpdate, ID_LogStyle_18, 0 ); }

// NumItem_LogStyle_18 is the number of items in the list 
#define NumItem_LogStyle_18 3

// SetListText_LogStyle_18 / SetListCount_LogStyle_18 define the contents of the list.
// If you need to modify the list items you may do so but you should then
// retransmit the dialog (i.e. call FxPC_SetDialog) to update the client.
// The items should be sequential, each separated from the next with a zero terminator,
// and the storage area originally allocated (ItemTextMaxBytes_LogStyle_18) should never
// be exceeded.  Call SetListCount_$s if you modify the number of items,
#define ListTextLoc_LogStyle_18 0x49AA
#define ListTextStr_LogStyle_18 STR_ROM01
#define SetListText_LogStyle_18( pRUStr, pUStr ) SetBytes( ListTextStr_LogStyle_18, ListTextLoc_LogStyle_18, pRUStr, pUStr, ItemTextMaxBytes_LogStyle_18 )
#define ListNumLoc_LogStyle_18 0x49A2
#define ListNumStr_LogStyle_18 STR_ROM01
#define SetListNum_LogStyle_18( pRUStr, pUStr ) SetBytes( ListNumStr_LogStyle_18, ListNumLoc_LogStyle_18, pRUStr, pUStr, sizeof( long ) )
#define ItemTextMaxBytes_LogStyle_18 0x003F

// EnsureVisible_LogStyle_18 scrolls control LogStyle into view on the client.  
#define EnsureVisible_LogStyle_18 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_LogStyle_18, &lVal ); }

// Show_LogStyle_18 sets that control LogStyle to visible.  
#define Show_LogStyle_18 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_LogStyle_18, &lVal ); }

// Hide_LogStyle_18 sets that control LogStyle to visible.  
#define Hide_LogStyle_18 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_LogStyle_18, &lVal ); }

// Enable_LogStyle_18 enables LogStyle.  
#define Enable_LogStyle_18 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_LogStyle_18, &lVal ); }

// Disable_LogStyle_18 disables LogStyle.  
#define Disable_LogStyle_18 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_LogStyle_18, &lVal ); }

// SetCol_LogStyle_18( NewCol ) sets the color of control LogStyle.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_LogStyle_18( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_LogStyle_18, lVal ); }


//-------------------------------------------------------------------------------------------

//  WeigandStyle control (4D - List)

#define ID_WeigandStyle_4D 0x0604    

// Get_WeigandStyle_4D( pLong ) gets WeigandStyle value.  pLong must be pointer to 4-byte signed integer
// if the value could fit into a short or char, you could get fewer bytes 
#define Get_WeigandStyle_4D( pLong ) GetBytes( STR_ROM01, 0x1D4C, pLong, sizeof(long) )

// pWeigandStyle_4D is an unsigned long ROM pointer which may also be used to get the value (use Set_WeigandStyle_4D() to set the value) 
#define pWeigandStyle_4D ((rom unsigned long*)0x011D4C)

// psWeigandStyle_4D is an unsigned short ROM pointer which may also be used to get the value if it is in the range 0 to 65535
#define psWeigandStyle_4D ((rom unsigned short*)0x011D4C)

// pcWeigandStyle_4D is an unsigned char ROM pointer which may also be used to get the value if it is in the range 0 to 255
#define pcWeigandStyle_4D ((rom unsigned char*)0x011D4C)

// Set_WeigandStyle_4D( pRLong, pLong ) sets WeigandStyle value.  pRULong must be rom pointer to 4-byte signed integer or pULong must 
// be pointer to 4-byte signed integer, the other pointer must be zero
// if the value could fit into a short or char, you could set fewer bytes 
#define Set_WeigandStyle_4D( pRLong, pULong ) SetBytes( STR_ROM01, 0x1D4C, pRULong, pULong, sizeof(long) )

// SetUp_WeigandStyle_4D( pRLong, pLong ) sets WeigandStyle value and automatically updates client if connected 
#define SetUp_WeigandStyle_4D( pRLong, pLong ) { Set_WeigandStyle_4D( pRLong, pLong ); FxPCommand( FxPC_CtlUpdate, ID_WeigandStyle_4D, 0 ); }

// NumItem_WeigandStyle_4D is the number of items in the list 
#define NumItem_WeigandStyle_4D 7

// SetListText_WeigandStyle_4D / SetListCount_WeigandStyle_4D define the contents of the list.
// If you need to modify the list items you may do so but you should then
// retransmit the dialog (i.e. call FxPC_SetDialog) to update the client.
// The items should be sequential, each separated from the next with a zero terminator,
// and the storage area originally allocated (ItemTextMaxBytes_WeigandStyle_4D) should never
// be exceeded.  Call SetListCount_$s if you modify the number of items,
#define ListTextLoc_WeigandStyle_4D 0x4A08
#define ListTextStr_WeigandStyle_4D STR_ROM01
#define SetListText_WeigandStyle_4D( pRUStr, pUStr ) SetBytes( ListTextStr_WeigandStyle_4D, ListTextLoc_WeigandStyle_4D, pRUStr, pUStr, ItemTextMaxBytes_WeigandStyle_4D )
#define ListNumLoc_WeigandStyle_4D 0x4A00
#define ListNumStr_WeigandStyle_4D STR_ROM01
#define SetListNum_WeigandStyle_4D( pRUStr, pUStr ) SetBytes( ListNumStr_WeigandStyle_4D, ListNumLoc_WeigandStyle_4D, pRUStr, pUStr, sizeof( long ) )
#define ItemTextMaxBytes_WeigandStyle_4D 0x00D8

// EnsureVisible_WeigandStyle_4D scrolls control WeigandStyle into view on the client.  
#define EnsureVisible_WeigandStyle_4D { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_WeigandStyle_4D, &lVal ); }

// Show_WeigandStyle_4D sets that control WeigandStyle to visible.  
#define Show_WeigandStyle_4D { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_WeigandStyle_4D, &lVal ); }

// Hide_WeigandStyle_4D sets that control WeigandStyle to visible.  
#define Hide_WeigandStyle_4D { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_WeigandStyle_4D, &lVal ); }

// Enable_WeigandStyle_4D enables WeigandStyle.  
#define Enable_WeigandStyle_4D { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_WeigandStyle_4D, &lVal ); }

// Disable_WeigandStyle_4D disables WeigandStyle.  
#define Disable_WeigandStyle_4D { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_WeigandStyle_4D, &lVal ); }

// SetCol_WeigandStyle_4D( NewCol ) sets the color of control WeigandStyle.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_WeigandStyle_4D( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_WeigandStyle_4D, lVal ); }


//-------------------------------------------------------------------------------------------

//  KeyText control (19 - Text)

#define ID_KeyText_19 0x0605    

// MaxBytes_KeyText_19 is maximum storage of KeyText in bytes
#define MaxBytes_KeyText_19 0x0012

// Get_KeyText_19( pUChar ) gets KeyText value.  pUChar must be pointer to unsigned char array, minimum length 18 bytes 
#define Get_KeyText_19( pUChar ) GetBytes( STR_ROM01, 0x1E2C, pUChar, 18 )

// pKeyText_19 is an unsigned char ROM pointer which may also be used to get the array (use Set_KeyText_19() to set it) 
#define pKeyText_19 ((rom unsigned char*)0x011E2C)

// Set_KeyText_19( pRUChar, pUChar ) sets KeyText value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_KeyText_19( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1E2C, pRUChar, pUChar, 18 )

// SetUp_KeyText_19( pRUChar, pUChar ) sets KeyText value and automatically updates client if connected 
#define SetUp_KeyText_19( pRUChar, pUChar ) { Set_KeyText_19( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_KeyText_19, 0 ); }

// EnsureVisible_KeyText_19 scrolls control KeyText into view on the client.  
#define EnsureVisible_KeyText_19 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_KeyText_19, &lVal ); }

// Show_KeyText_19 sets that control KeyText to visible.  
#define Show_KeyText_19 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_KeyText_19, &lVal ); }

// Hide_KeyText_19 sets that control KeyText to visible.  
#define Hide_KeyText_19 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_KeyText_19, &lVal ); }

// Enable_KeyText_19 enables KeyText.  
#define Enable_KeyText_19 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_KeyText_19, &lVal ); }

// Disable_KeyText_19 disables KeyText.  
#define Disable_KeyText_19 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_KeyText_19, &lVal ); }

// SetCol_KeyText_19( NewCol ) sets the color of control KeyText.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_KeyText_19( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_KeyText_19, lVal ); }


//-------------------------------------------------------------------------------------------

//  Key control (1C - Text)

#define ID_Key_1C 0x0606    

// MaxBytes_Key_1C is maximum storage of Key in bytes
#define MaxBytes_Key_1C 0x0009

// Get_Key_1C( pUChar ) gets Key value.  pUChar must be pointer to unsigned char array, minimum length 9 bytes 
#define Get_Key_1C( pUChar ) GetBytes( STR_ROM01, 0x1EFF, pUChar, 9 )

// pKey_1C is an unsigned char ROM pointer which may also be used to get the array (use Set_Key_1C() to set it) 
#define pKey_1C ((rom unsigned char*)0x011EFF)

// Set_Key_1C( pRUChar, pUChar ) sets Key value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_Key_1C( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1EFF, pRUChar, pUChar, 9 )

// SetUp_Key_1C( pRUChar, pUChar ) sets Key value and automatically updates client if connected 
#define SetUp_Key_1C( pRUChar, pUChar ) { Set_Key_1C( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_Key_1C, 0 ); }

// EnsureVisible_Key_1C scrolls control Key into view on the client.  
#define EnsureVisible_Key_1C { unsigned long lVal = 0x00010010; FxPCommand( FxPC_SetProps, ID_Key_1C, &lVal ); }

// Show_Key_1C sets that control Key to visible.  
#define Show_Key_1C { unsigned long lVal = 0x00010000; FxPCommand( FxPC_SetProps, ID_Key_1C, &lVal ); }

// Hide_Key_1C sets that control Key to visible.  
#define Hide_Key_1C { unsigned long lVal = 0x00010001; FxPCommand( FxPC_SetProps, ID_Key_1C, &lVal ); }

// Enable_Key_1C enables Key.  
#define Enable_Key_1C { unsigned long lVal = 0x00010000; FxPCommand( FxPC_SetProps, ID_Key_1C, &lVal ); }

// Disable_Key_1C disables Key.  
#define Disable_Key_1C { unsigned long lVal = 0x00010080; FxPCommand( FxPC_SetProps, ID_Key_1C, &lVal ); }

// SetCol_Key_1C( NewCol ) sets the color of control Key.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Key_1C( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00010040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Key_1C, lVal ); }


//-------------------------------------------------------------------------------------------

//  UserPinText control (41 - Text)

#define ID_UserPinText_41 0x0607    

// MaxBytes_UserPinText_41 is maximum storage of UserPinText in bytes
#define MaxBytes_UserPinText_41 0x000D

// Get_UserPinText_41( pUChar ) gets UserPinText value.  pUChar must be pointer to unsigned char array, minimum length 13 bytes 
#define Get_UserPinText_41( pUChar ) GetBytes( STR_ROM01, 0x1F08, pUChar, 13 )

// pUserPinText_41 is an unsigned char ROM pointer which may also be used to get the array (use Set_UserPinText_41() to set it) 
#define pUserPinText_41 ((rom unsigned char*)0x011F08)

// Set_UserPinText_41( pRUChar, pUChar ) sets UserPinText value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_UserPinText_41( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1F08, pRUChar, pUChar, 13 )

// SetUp_UserPinText_41( pRUChar, pUChar ) sets UserPinText value and automatically updates client if connected 
#define SetUp_UserPinText_41( pRUChar, pUChar ) { Set_UserPinText_41( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_UserPinText_41, 0 ); }

// EnsureVisible_UserPinText_41 scrolls control UserPinText into view on the client.  
#define EnsureVisible_UserPinText_41 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_UserPinText_41, &lVal ); }

// Show_UserPinText_41 sets that control UserPinText to visible.  
#define Show_UserPinText_41 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_UserPinText_41, &lVal ); }

// Hide_UserPinText_41 sets that control UserPinText to visible.  
#define Hide_UserPinText_41 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_UserPinText_41, &lVal ); }

// Enable_UserPinText_41 enables UserPinText.  
#define Enable_UserPinText_41 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_UserPinText_41, &lVal ); }

// Disable_UserPinText_41 disables UserPinText.  
#define Disable_UserPinText_41 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_UserPinText_41, &lVal ); }

// SetCol_UserPinText_41( NewCol ) sets the color of control UserPinText.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_UserPinText_41( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_UserPinText_41, lVal ); }


//-------------------------------------------------------------------------------------------

//  UserPinKey control (42 - Text)

#define ID_UserPinKey_42 0x0608    

// MaxBytes_UserPinKey_42 is maximum storage of UserPinKey in bytes
#define MaxBytes_UserPinKey_42 0x0009

// Get_UserPinKey_42( pUChar ) gets UserPinKey value.  pUChar must be pointer to unsigned char array, minimum length 9 bytes 
#define Get_UserPinKey_42( pUChar ) GetBytes( STR_ROM01, 0x1F15, pUChar, 9 )

// pUserPinKey_42 is an unsigned char ROM pointer which may also be used to get the array (use Set_UserPinKey_42() to set it) 
#define pUserPinKey_42 ((rom unsigned char*)0x011F15)

// Set_UserPinKey_42( pRUChar, pUChar ) sets UserPinKey value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_UserPinKey_42( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1F15, pRUChar, pUChar, 9 )

// SetUp_UserPinKey_42( pRUChar, pUChar ) sets UserPinKey value and automatically updates client if connected 
#define SetUp_UserPinKey_42( pRUChar, pUChar ) { Set_UserPinKey_42( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_UserPinKey_42, 0 ); }

// EnsureVisible_UserPinKey_42 scrolls control UserPinKey into view on the client.  
#define EnsureVisible_UserPinKey_42 { unsigned long lVal = 0x00010010; FxPCommand( FxPC_SetProps, ID_UserPinKey_42, &lVal ); }

// Show_UserPinKey_42 sets that control UserPinKey to visible.  
#define Show_UserPinKey_42 { unsigned long lVal = 0x00010000; FxPCommand( FxPC_SetProps, ID_UserPinKey_42, &lVal ); }

// Hide_UserPinKey_42 sets that control UserPinKey to visible.  
#define Hide_UserPinKey_42 { unsigned long lVal = 0x00010001; FxPCommand( FxPC_SetProps, ID_UserPinKey_42, &lVal ); }

// Enable_UserPinKey_42 enables UserPinKey.  
#define Enable_UserPinKey_42 { unsigned long lVal = 0x00010000; FxPCommand( FxPC_SetProps, ID_UserPinKey_42, &lVal ); }

// Disable_UserPinKey_42 disables UserPinKey.  
#define Disable_UserPinKey_42 { unsigned long lVal = 0x00010080; FxPCommand( FxPC_SetProps, ID_UserPinKey_42, &lVal ); }

// SetCol_UserPinKey_42( NewCol ) sets the color of control UserPinKey.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_UserPinKey_42( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00010040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_UserPinKey_42, lVal ); }


//-------------------------------------------------------------------------------------------

//  TimeNowText control (22 - Text)

#define ID_TimeNowText_22 0x0609    

// MaxBytes_TimeNowText_22 is maximum storage of TimeNowText in bytes
#define MaxBytes_TimeNowText_22 0x0010

// Get_TimeNowText_22( pUChar ) gets TimeNowText value.  pUChar must be pointer to unsigned char array, minimum length 16 bytes 
#define Get_TimeNowText_22( pUChar ) GetBytes( STR_ROM01, 0x1D50, pUChar, 16 )

// pTimeNowText_22 is an unsigned char ROM pointer which may also be used to get the array (use Set_TimeNowText_22() to set it) 
#define pTimeNowText_22 ((rom unsigned char*)0x011D50)

// Set_TimeNowText_22( pRUChar, pUChar ) sets TimeNowText value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_TimeNowText_22( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1D50, pRUChar, pUChar, 16 )

// SetUp_TimeNowText_22( pRUChar, pUChar ) sets TimeNowText value and automatically updates client if connected 
#define SetUp_TimeNowText_22( pRUChar, pUChar ) { Set_TimeNowText_22( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_TimeNowText_22, 0 ); }

// EnsureVisible_TimeNowText_22 scrolls control TimeNowText into view on the client.  
#define EnsureVisible_TimeNowText_22 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_TimeNowText_22, &lVal ); }

// Show_TimeNowText_22 sets that control TimeNowText to visible.  
#define Show_TimeNowText_22 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_TimeNowText_22, &lVal ); }

// Hide_TimeNowText_22 sets that control TimeNowText to visible.  
#define Hide_TimeNowText_22 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_TimeNowText_22, &lVal ); }

// Enable_TimeNowText_22 enables TimeNowText.  
#define Enable_TimeNowText_22 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_TimeNowText_22, &lVal ); }

// Disable_TimeNowText_22 disables TimeNowText.  
#define Disable_TimeNowText_22 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_TimeNowText_22, &lVal ); }

// SetCol_TimeNowText_22( NewCol ) sets the color of control TimeNowText.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_TimeNowText_22( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_TimeNowText_22, lVal ); }


//-------------------------------------------------------------------------------------------

//  TimeNow control (23 - DateTime)

#define ID_TimeNow_23 0x060A    

// Get_TimeNow_23( pDT ) gets TimeNow value.  pDT must be pointer to DateTimeU struct as defined in ToothPIC.h
#define Get_TimeNow_23( pDT ) GetBytes( STR_RAM, 0x0024, pDT, sizeof(DateTimeU) )

// pTimeNow_23 is a DateTimeU RAM pointer which may also be used to set or get the value
#define pTimeNow_23 ((DateTimeU*)0x0124)

// Set_TimeNow_23( pRDT, pDT ) sets TimeNow value.  pRDT must be rom pointer to DateTimeU struct or pDT must 
// be pointer to DateTimeU struct, the other pointer must be zero
#define Set_TimeNow_23( pRDT, pDT ) SetBytes( STR_RAM, 0x0024, pRDT, pDT, sizeof(DateTimeU) )

// SetUp_TimeNow_23( pRUChar, pUChar ) sets TimeNow value and automatically updates client if connected 
#define SetUp_TimeNow_23( pRUChar, pUChar ) { Set_TimeNow_23( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_TimeNow_23, 0 ); }

// EnsureVisible_TimeNow_23 scrolls control TimeNow into view on the client.  
#define EnsureVisible_TimeNow_23 { unsigned long lVal = 0x01EF0010; FxPCommand( FxPC_SetProps, ID_TimeNow_23, &lVal ); }

// Show_TimeNow_23 sets that control TimeNow to visible.  
#define Show_TimeNow_23 { unsigned long lVal = 0x01EF0000; FxPCommand( FxPC_SetProps, ID_TimeNow_23, &lVal ); }

// Hide_TimeNow_23 sets that control TimeNow to visible.  
#define Hide_TimeNow_23 { unsigned long lVal = 0x01EF0001; FxPCommand( FxPC_SetProps, ID_TimeNow_23, &lVal ); }

// Enable_TimeNow_23 enables TimeNow.  
#define Enable_TimeNow_23 { unsigned long lVal = 0x01EF0000; FxPCommand( FxPC_SetProps, ID_TimeNow_23, &lVal ); }

// Disable_TimeNow_23 disables TimeNow.  
#define Disable_TimeNow_23 { unsigned long lVal = 0x01EF0080; FxPCommand( FxPC_SetProps, ID_TimeNow_23, &lVal ); }

// SetCol_TimeNow_23( NewCol ) sets the color of control TimeNow.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_TimeNow_23( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x01EF0040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_TimeNow_23, lVal ); }


//-------------------------------------------------------------------------------------------

//  DTSStyle control (24 - List)

#define ID_DTSStyle_24 0x060B    

// Get_DTSStyle_24( pLong ) gets DTSStyle value.  pLong must be pointer to 4-byte signed integer
// if the value could fit into a short or char, you could get fewer bytes 
#define Get_DTSStyle_24( pLong ) GetBytes( STR_ROM01, 0x1D60, pLong, sizeof(long) )

// pDTSStyle_24 is an unsigned long ROM pointer which may also be used to get the value (use Set_DTSStyle_24() to set the value) 
#define pDTSStyle_24 ((rom unsigned long*)0x011D60)

// psDTSStyle_24 is an unsigned short ROM pointer which may also be used to get the value if it is in the range 0 to 65535
#define psDTSStyle_24 ((rom unsigned short*)0x011D60)

// pcDTSStyle_24 is an unsigned char ROM pointer which may also be used to get the value if it is in the range 0 to 255
#define pcDTSStyle_24 ((rom unsigned char*)0x011D60)

// Set_DTSStyle_24( pRLong, pLong ) sets DTSStyle value.  pRULong must be rom pointer to 4-byte signed integer or pULong must 
// be pointer to 4-byte signed integer, the other pointer must be zero
// if the value could fit into a short or char, you could set fewer bytes 
#define Set_DTSStyle_24( pRLong, pULong ) SetBytes( STR_ROM01, 0x1D60, pRULong, pULong, sizeof(long) )

// SetUp_DTSStyle_24( pRLong, pLong ) sets DTSStyle value and automatically updates client if connected 
#define SetUp_DTSStyle_24( pRLong, pLong ) { Set_DTSStyle_24( pRLong, pLong ); FxPCommand( FxPC_CtlUpdate, ID_DTSStyle_24, 0 ); }

// NumItem_DTSStyle_24 is the number of items in the list 
#define NumItem_DTSStyle_24 27

// SetListText_DTSStyle_24 / SetListCount_DTSStyle_24 define the contents of the list.
// If you need to modify the list items you may do so but you should then
// retransmit the dialog (i.e. call FxPC_SetDialog) to update the client.
// The items should be sequential, each separated from the next with a zero terminator,
// and the storage area originally allocated (ItemTextMaxBytes_DTSStyle_24) should never
// be exceeded.  Call SetListCount_$s if you modify the number of items,
#define ListTextLoc_DTSStyle_24 0x4BC2
#define ListTextStr_DTSStyle_24 STR_ROM01
#define SetListText_DTSStyle_24( pRUStr, pUStr ) SetBytes( ListTextStr_DTSStyle_24, ListTextLoc_DTSStyle_24, pRUStr, pUStr, ItemTextMaxBytes_DTSStyle_24 )
#define ListNumLoc_DTSStyle_24 0x4BBA
#define ListNumStr_DTSStyle_24 STR_ROM01
#define SetListNum_DTSStyle_24( pRUStr, pUStr ) SetBytes( ListNumStr_DTSStyle_24, ListNumLoc_DTSStyle_24, pRUStr, pUStr, sizeof( long ) )
#define ItemTextMaxBytes_DTSStyle_24 0x02A4

// EnsureVisible_DTSStyle_24 scrolls control DTSStyle into view on the client.  
#define EnsureVisible_DTSStyle_24 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_DTSStyle_24, &lVal ); }

// Show_DTSStyle_24 sets that control DTSStyle to visible.  
#define Show_DTSStyle_24 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_DTSStyle_24, &lVal ); }

// Hide_DTSStyle_24 sets that control DTSStyle to visible.  
#define Hide_DTSStyle_24 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_DTSStyle_24, &lVal ); }

// Enable_DTSStyle_24 enables DTSStyle.  
#define Enable_DTSStyle_24 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_DTSStyle_24, &lVal ); }

// Disable_DTSStyle_24 disables DTSStyle.  
#define Disable_DTSStyle_24 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_DTSStyle_24, &lVal ); }

// SetCol_DTSStyle_24( NewCol ) sets the color of control DTSStyle.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_DTSStyle_24( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_DTSStyle_24, lVal ); }


//-------------------------------------------------------------------------------------------

//  In DST now control (4E - Latch)

#define ID_In_DST_now_4E 0x060C    

// Latch values are 0xFF for On and 0x00 for Off
// Get_In_DST_now_4E( pUChar ) gets In DST now value.  pUChar must be pointer to unsigned char
#define Get_In_DST_now_4E( pUChar ) GetBytes( STR_RAM, 0x006A, pUChar, sizeof(unsigned char) )

// pIn_DST_now_4E is an unsigned char RAM pointer which may also be used to set or get the value
#define pIn_DST_now_4E ((unsigned char*)0x016A)

// Set_In_DST_now_4E( pRUChar, pUChar ) sets In DST now value.  pRUChar must be rom pointer to unsigned char or pUChar must 
// be pointer to unsigned char, the other pointer must be zero
#define Set_In_DST_now_4E( pRUChar, pUChar ) SetBytes( STR_RAM, 0x006A, pRUChar, pUChar, sizeof(unsigned char) )

// SetUp_In_DST_now_4E( pRUChar, pUChar ) sets In DST now value and automatically updates client if connected 
#define SetUp_In_DST_now_4E( pRUChar, pUChar ) { Set_In_DST_now_4E( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_In_DST_now_4E, 0 ); }

// EnsureVisible_In_DST_now_4E scrolls control In DST now into view on the client.  
#define EnsureVisible_In_DST_now_4E { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_In_DST_now_4E, &lVal ); }

// Show_In_DST_now_4E sets that control In DST now to visible.  
#define Show_In_DST_now_4E { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_In_DST_now_4E, &lVal ); }

// Hide_In_DST_now_4E sets that control In DST now to visible.  
#define Hide_In_DST_now_4E { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_In_DST_now_4E, &lVal ); }

// Enable_In_DST_now_4E enables In DST now.  
#define Enable_In_DST_now_4E { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_In_DST_now_4E, &lVal ); }

// Disable_In_DST_now_4E disables In DST now.  
#define Disable_In_DST_now_4E { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_In_DST_now_4E, &lVal ); }

// SetCol_In_DST_now_4E( NewCol ) sets the color of control In DST now.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_In_DST_now_4E( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_In_DST_now_4E, lVal ); }


//-------------------------------------------------------------------------------------------

//  Close control (21 - Button)

#define ID_Close_21 0x060D    

// EnsureVisible_Close_21 scrolls control Close into view on the client.  
#define EnsureVisible_Close_21 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Close_21, &lVal ); }

// Show_Close_21 sets that control Close to visible.  
#define Show_Close_21 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Close_21, &lVal ); }

// Hide_Close_21 sets that control Close to visible.  
#define Hide_Close_21 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Close_21, &lVal ); }

// Enable_Close_21 enables Close.  
#define Enable_Close_21 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Close_21, &lVal ); }

// Disable_Close_21 disables Close.  
#define Disable_Close_21 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Close_21, &lVal ); }

// SetCol_Close_21( NewCol ) sets the color of control Close.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Close_21( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Close_21, lVal ); }


//-------------------------------------------------------------------------------------------

//  WarnText control (46 - Text)

#define ID_WarnText_46 0x0701    

// MaxBytes_WarnText_46 is maximum storage of WarnText in bytes
#define MaxBytes_WarnText_46 0x0010

// Get_WarnText_46( pUChar ) gets WarnText value.  pUChar must be pointer to unsigned char array, minimum length 16 bytes 
#define Get_WarnText_46( pUChar ) GetBytes( STR_ROM01, 0x1D64, pUChar, 16 )

// pWarnText_46 is an unsigned char ROM pointer which may also be used to get the array (use Set_WarnText_46() to set it) 
#define pWarnText_46 ((rom unsigned char*)0x011D64)

// Set_WarnText_46( pRUChar, pUChar ) sets WarnText value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_WarnText_46( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x1D64, pRUChar, pUChar, 16 )

// SetUp_WarnText_46( pRUChar, pUChar ) sets WarnText value and automatically updates client if connected 
#define SetUp_WarnText_46( pRUChar, pUChar ) { Set_WarnText_46( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_WarnText_46, 0 ); }

// EnsureVisible_WarnText_46 scrolls control WarnText into view on the client.  
#define EnsureVisible_WarnText_46 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_WarnText_46, &lVal ); }

// Show_WarnText_46 sets that control WarnText to visible.  
#define Show_WarnText_46 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_WarnText_46, &lVal ); }

// Hide_WarnText_46 sets that control WarnText to visible.  
#define Hide_WarnText_46 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_WarnText_46, &lVal ); }

// Enable_WarnText_46 enables WarnText.  
#define Enable_WarnText_46 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_WarnText_46, &lVal ); }

// Disable_WarnText_46 disables WarnText.  
#define Disable_WarnText_46 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_WarnText_46, &lVal ); }

// SetCol_WarnText_46( NewCol ) sets the color of control WarnText.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_WarnText_46( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_WarnText_46, lVal ); }


//-------------------------------------------------------------------------------------------

//  UserName control (47 - Text)

#define ID_UserName_47 0x0702    

// MaxBytes_UserName_47 is maximum storage of UserName in bytes
#define MaxBytes_UserName_47 0x0013

// Get_UserName_47( pUChar ) gets UserName value.  pUChar must be pointer to unsigned char array, minimum length 19 bytes 
#define Get_UserName_47( pUChar ) GetBytes( STR_RAM, 0x006B, pUChar, 19 )

// pUserName_47 is an unsigned char RAM pointer which may also be used to set or get the array
#define pUserName_47 ((unsigned char*)0x016B)

// Set_UserName_47( pRUChar, pUChar ) sets UserName value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_UserName_47( pRUChar, pUChar ) SetBytes( STR_RAM, 0x006B, pRUChar, pUChar, 19 )

// SetUp_UserName_47( pRUChar, pUChar ) sets UserName value and automatically updates client if connected 
#define SetUp_UserName_47( pRUChar, pUChar ) { Set_UserName_47( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_UserName_47, 0 ); }

// EnsureVisible_UserName_47 scrolls control UserName into view on the client.  
#define EnsureVisible_UserName_47 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_UserName_47, &lVal ); }

// Show_UserName_47 sets that control UserName to visible.  
#define Show_UserName_47 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_UserName_47, &lVal ); }

// Hide_UserName_47 sets that control UserName to visible.  
#define Hide_UserName_47 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_UserName_47, &lVal ); }

// Enable_UserName_47 enables UserName.  
#define Enable_UserName_47 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_UserName_47, &lVal ); }

// Disable_UserName_47 disables UserName.  
#define Disable_UserName_47 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_UserName_47, &lVal ); }

// SetCol_UserName_47( NewCol ) sets the color of control UserName.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_UserName_47( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_UserName_47, lVal ); }


//-------------------------------------------------------------------------------------------

//  Confirm control (48 - Button)

#define ID_Confirm_48 0x0703    

// EnsureVisible_Confirm_48 scrolls control Confirm into view on the client.  
#define EnsureVisible_Confirm_48 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Confirm_48, &lVal ); }

// Show_Confirm_48 sets that control Confirm to visible.  
#define Show_Confirm_48 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Confirm_48, &lVal ); }

// Hide_Confirm_48 sets that control Confirm to visible.  
#define Hide_Confirm_48 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Confirm_48, &lVal ); }

// Enable_Confirm_48 enables Confirm.  
#define Enable_Confirm_48 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Confirm_48, &lVal ); }

// Disable_Confirm_48 disables Confirm.  
#define Disable_Confirm_48 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Confirm_48, &lVal ); }

// SetCol_Confirm_48( NewCol ) sets the color of control Confirm.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Confirm_48( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Confirm_48, lVal ); }


//-------------------------------------------------------------------------------------------

//  Cancel control (49 - Button)

#define ID_Cancel_49 0x0704    

// EnsureVisible_Cancel_49 scrolls control Cancel into view on the client.  
#define EnsureVisible_Cancel_49 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Cancel_49, &lVal ); }

// Show_Cancel_49 sets that control Cancel to visible.  
#define Show_Cancel_49 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Cancel_49, &lVal ); }

// Hide_Cancel_49 sets that control Cancel to visible.  
#define Hide_Cancel_49 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Cancel_49, &lVal ); }

// Enable_Cancel_49 enables Cancel.  
#define Enable_Cancel_49 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Cancel_49, &lVal ); }

// Disable_Cancel_49 disables Cancel.  
#define Disable_Cancel_49 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Cancel_49, &lVal ); }

// SetCol_Cancel_49( NewCol ) sets the color of control Cancel.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Cancel_49( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Cancel_49, lVal ); }


//-------------------------------------------------------------------------------------------

//  Other definitions 

// DESIGNERCHOOSESNAME definition ensures that the profile is uploaded every time this file
// is regenerated
#define DESIGNERCHOOSESNAME
#define DESIGNERCHOSENNAME "OpenTooth1"

//
//-------------------------------------------------------------------------------------------

