//-------------------------------------------------------------------------------------------
//
//  SlaveDefRes.h
//
//  ToothPIC User Interface and mesh map definitions generated by FlexiPanel Designer 
//
//  Created at 19:18:17 on 5/21/05
//
//  ROM allocation: 0x010000 to 0x0101D6
//  RAM allocation:   0x0100 to   0x0101
//
//-------------------------------------------------------------------------------------------
//
//                      MEMORY MAP 
//
//    Addresses are relative to start of storage identifier 
//
//     Storage     Address    Size     Allocation 
//    =========    =======   ======    ================================ 
//    STR_RAM01     0000      0020     FlexiPanel server info (DWord aligned)
//    STR_RAM01     0020      0004     Dialog info array (DWord aligned)
//    STR_RAM01     0024      0170     Client-specific profile info array (DWord aligned)
//    STR_RAM01     0194      001C     Control info array (DWord aligned)
//    STR_ROM01     01B0      0010     Text3 (03) value (DWord aligned)
//    STR_ROM01     01C0      0017     Text3 (03) control info
//
//-------------------------------------------------------------------------------------------
//
//
//  Dialog definitions 

// Dialog index / data structure for dialog whose first control is Text3 
#define DlgID_Text3_3 0x00    
#define DlgD_Text3_3 pDlgD[DlgID_Text3_3]    


//-------------------------------------------------------------------------------------------

//  Text3 control (03 - Text)

// Control ID
#define ID_Text3_3 0x0001    

// Control Index / data structure pointer 
#define CtlIdx_Text3_3 0x0000    
#define CtlD_Text3_3 pCtlD[CtlIdx_Text3_3]    

// MaxBytes_Text3_3 is maximum storage of Text3 in bytes
#define MaxBytes_Text3_3 0x0010

// Get_Text3_3( pUChar ) gets Text3 value.  pUChar must be pointer to unsigned char array, minimum length 16 bytes 
#define Get_Text3_3( pUChar ) GetBytes( STR_ROM01, 0x01B0, pUChar, 16 )

// pText3_3 is an unsigned char ROM pointer which may also be used to get the array (use Set_Text3_3() to set it) 
#define pText3_3 ((rom unsigned char*)0x0101B0)

// Set_Text3_3( pRUChar, pUChar ) sets Text3 value.  pRUChar must be rom pointer to unsigned char array or pUChar must 
// be pointer to unsigned char, the other pointer must be zero, must include zero terminator
#define Set_Text3_3( pRUChar, pUChar ) SetBytes( STR_ROM01, 0x01B0, pRUChar, pUChar, 16 )

// SetUp_Text3_3( pRUChar, pUChar ) sets Text3 value and automatically updates client if connected 
#define SetUp_Text3_3( pRUChar, pUChar ) { Set_Text3_3( pRUChar, pUChar ); FxPCommand( FxPC_CtlUpdate, ID_Text3_3, 0 ); }

// EnsureVisible_Text3_3 scrolls control Text3 into view on the client.  
#define EnsureVisible_Text3_3 { unsigned long lVal = 0x00000010; FxPCommand( FxPC_SetProps, ID_Text3_3, &lVal ); }

// Show_Text3_3 sets that control Text3 to visible.  
#define Show_Text3_3 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Text3_3, &lVal ); }

// Hide_Text3_3 sets that control Text3 to visible.  
#define Hide_Text3_3 { unsigned long lVal = 0x00000001; FxPCommand( FxPC_SetProps, ID_Text3_3, &lVal ); }

// Enable_Text3_3 enables Text3.  
#define Enable_Text3_3 { unsigned long lVal = 0x00000000; FxPCommand( FxPC_SetProps, ID_Text3_3, &lVal ); }

// Disable_Text3_3 disables Text3.  
#define Disable_Text3_3 { unsigned long lVal = 0x00000080; FxPCommand( FxPC_SetProps, ID_Text3_3, &lVal ); }

// SetCol_Text3_3( NewCol ) sets the color of control Text3.  Col must be a Microsoft COLORREF value or constant (i.e. 0x00BBGGRR) 
#define SetCol_Text3_3( NewCol ) { unsigned long lVal[2]; lVal[0] = 0x00000040; lVal[1] = NewCol; FxPCommand( FxPC_SetProps, ID_Text3_3, lVal ); }


//-------------------------------------------------------------------------------------------

//  Other definitions 

// DESIGNERCHOOSESNAME definition ensures that the profile is uploaded every time this file
// is regenerated
#define DESIGNERCHOOSESNAME
#define DESIGNERCHOSENNAME "ToothPIC Slave"

//
//-------------------------------------------------------------------------------------------

